/*******************************************************************************
*
* File:         S20_demo.c
* Description:  ϵͳļ
* Version:      V0.1
* Date:         2020-02-22
* Author:       Tempest
 *******************************************************************************/

#include "ap_demo.h"
#include "ArmCM0.h"
#include "tau_device_datatype.h"
#include "tau_log.h"
#include "tau_operations.h"
#include "tau_common.h"
#include "tau_delay.h"
#include "hal_dsi_rx_ctrl.h"
#include "hal_dsi_tx_ctrl.h"
#include "hal_swire.h"
#include "hal_timer.h"
#include "hal_system.h"
#include "hal_gpio.h"
#include "hal_pwm.h"


#include "app_tp_transfer.h"
#ifdef LOG_TAG
#undef LOG_TAG
#endif
#define LOG_TAG "Pixel7_pro_demo"

/*****************************************/

//S8 MIPIϢ
/* ֱ */
#define INPUT_WIDTH  1440
#define INPUT_HEIGHT 3120
/*  MIPI lane rate,video modeҪȷãcmd mode */
#define INPUT_MIPI_LANE_RATE   1500000000  //1250000000//1500000000
/* ͼʽ */
#define INPUT_COLOR_MODE DSI_RGB888
/* ݸʽ(DSI_DATA_CMD_MODE , DSI_DATA_VIDEO_MODE) */
#define INPUT_DATA_MODE DSI_DATA_CMD_MODE
/* mipi lane(DSI_RX_LANE_x     xΪ1-4) */
#define INPUT_MIPI_LANE_NUM DSI_LANE_4
/* Ϊvideo mode ʱݸʽ */
#define INPUT_VIDEO_MODEL DSI_NONBURST_EVENT
/* ͨ(0-3) */
#define INPUT_VC DSI_VC_0
/* ֡(60/90/120/144Hz) */
#define INPUT_FRAME_RATE DSI_FRAME_RATE_120HZ
/* ǷDSCѹ */
#define INPUT_COMPRESS true
#define OUTPUT_FRAME_RATE      60//60*

#if AMOLED_NT37701_CSOT667

/* ֱ */
#define OUTPUT_WIDTH   1080
#define OUTPUT_HEIGHT 2400
/* ͨ(0-3) */
#define OUTPUT_VC DSI_VC_0
/* mipi lane(DSI_RX_LANE_x     xΪ1-4) */
#define OUTPUT_LANE_NUMBER DSI_LANE_4
/* Ϊvideo mode ݸʽ */
#define OUTPUT_VIDEO_MODEL DSI_BURST_MODE
#if 0
/*  VSA */
#define OUTPUT_VSA  2
/*  VBP */
#define OUTPUT_VBP  58//64
/*  VBP */
#define OUTPUT_VFP  62
/*  VSA */
#define OUTPUT_HSA  4
/*  HBP */
#define OUTPUT_HBP  16
/*  HFP */
#define OUTPUT_HFP  18
#else
#define OUTPUT_VSA  12//8//4
/*  VBP */
#define OUTPUT_VBP  8
/*  VBP */
#define OUTPUT_VFP  56//72
/*  VSA */
#define OUTPUT_HSA  8
/*  HBP */
#define OUTPUT_HBP  12//92
/*  HFP */
#define OUTPUT_HFP  120//100
/* ʼģʽ */
#endif
#define _CMD_TYPE            DSI_CMD_TX_LP      //0-HS,1-LP;
#endif

#define SWIRE_TIMER TIMER_NUM1
#define TE_TIMER    TIMER_NUM2
#ifdef USE_FOR_SUMSUNG_S20
#define ENABLE_TP_WAKE_UP          true
#define SWIRE_MAX_NUM       24
#else
#define SWIRE_MAX_NUM       40
#endif

#define ADD_TP_CALIBRATION      0//1
#define AUTO_CAL_TP             0
#define RUN_TEST                0

#if ADD_TP_CALIBRATION
static volatile bool g_calibration_flag = false;
#endif

#ifdef RUN_TEST
static __attribute__((unused)) uint8_t g_run_test_cnt = 0;   //leo
#endif

#if AUTO_CAL_TP
static uint16_t g_cal_cnt = 300;    //3sʱTPУ׼
#endif

static __attribute__((unused)) uint8_t send_29_flag = 0;  // ʼ29ָȡ1⡣
#if ENABLE_TP_WAKE_UP
#define POWER_IO_A IO_PAD_TD_LEDPWM     //C2 IO_PWRCTRL  /* ӦIOҪ */
#define POWER_IO_B IO_PAD_TD_SPIM_MISO  /* ӦIOҪ */
#endif
//#define DISPLAY_ONLY
#define CUS_SCLD_FILTER true
#define NEW_ACK_CMD_FUNC true

/******************************************************/
static hal_dsi_rx_ctrl_handle_t *g_rx_ctrl_handle = NULL;
static hal_dsi_tx_ctrl_handle_t *g_tx_ctrl_handle = NULL;

#ifdef USE_FOR_SUMSUNG_S20
//S20  SWIRE=50->ELVSS=-1.7V
#define SWIRE_DEFAULT_NUM       50
#else
#define SWIRE_DEFAULT_NUM       38
#endif

#define SYNC_LIN_NUMBER         3020//3120 2720
#define TX_LINE_DELAY           1400//2200

static uint8_t swire_num = SWIRE_DEFAULT_NUM;
static __attribute__((unused)) uint8_t swire_num_bak = SWIRE_DEFAULT_NUM;

/* Ĭfalse,ʼ־λ,ʹTP1.8V,AC ʼҪTP1.8Vе */
static volatile bool start_display_on = true;
static __attribute__((unused)) bool g_exit_sleep_mode = false;

#if ENABLE_TP_WAKE_UP
static bool g_need_enter_sleep_mode = false;
#endif

/* ʼɱ־λ */
static __attribute__((unused)) bool panel_display_done = false;
//static bool g_panel_init_done = false;
static volatile bool g_resolution_change = false;
static void swire_init(void);
void Gpio_swire_output(uint8_t flag, uint8_t num);

#ifdef USE_FOR_Google_Pixel6pro
uint8_t Flag_blacklight_EN;//extern
uint8_t tp_sleep_in;//extern
uint8_t tp_sleep_count;//extern
uint8_t phone_start_flag = 0;
uint16_t phone_DisplayOFF_count = 0;
uint8_t phone_DisplayOFF_flag = 0;
uint16_t phone_tempcount = 0;
uint16_t flag_test_count = 0;
static bool g_mipi_path_off = false;
#endif

uint32_t s_heartbeat = 0;

#if ENABLE_TP_WAKE_UP

static void ap_reset_cb(void *data)
{
	/* лԴ */
	//    hal_gpio_set_output_data_ex(POWER_IO_B, IO_LVL_HIGH, POWER_IO_A, IO_LVL_LOW);
	hal_gpio_set_output_data(POWER_IO_A, IO_LVL_LOW);//
	/* VCC */
	TAU_LOGD("disable reset!!!!!!!!!!!!!!!!!!!!!!!!!!");
	hal_system_set_pvd(true);
	hal_system_set_vcc(true);
	NVIC_SystemReset();
}
#endif



static bool ap_dcs_read(uint8_t data_type, uint8_t dcs_cmd, uint8_t param)
{
	if (dcs_cmd == 0x04)
	{
		phone_DisplayOFF_flag = 1;
		hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
		                             DSI_ACK_DT_DSC_LONG_RESPONSE,
		                             DSI_VC_0,
		                             3, 0x0A, 0x68, 0x07);
	}
	else if (dcs_cmd == 0xa1)
	{
		hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
		                             DSI_ACK_DT_DSC_LONG_RESPONSE,
		                             DSI_VC_0,
		                             13, 0x0C, 0x21, 0x0C, 0xC6, 0x01, 0xF3, 0xAA, 0x11, 0x06, 0x2B, 0x25, 0x21, 0xF6);
	}
	else if (dcs_cmd == 0xDA)
	{
		hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
		                             DSI_ACK_DT_DSC_SHORT_RESPONSE_1B,
		                             DSI_VC_0,
		                             1, 0x0A);
	}
	else if (dcs_cmd == 0xDB)
	{
		hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
		                             DSI_ACK_DT_DSC_SHORT_RESPONSE_1B,
		                             DSI_VC_0,
		                             1, 0x68);
	}
	else if (dcs_cmd == 0xDC)
	{
		hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
		                             DSI_ACK_DT_DSC_SHORT_RESPONSE_1B,
		                             DSI_VC_0,
		                             1, 0x07);
	}
	else if (dcs_cmd == 0xD6)
	{
		hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
		                             DSI_ACK_DT_DSC_LONG_RESPONSE,
		                             DSI_VC_0,
		                             5, 0xF0, 0xEA, 0x85, 0x61, 0x86);
	}
	else
	{
		uint32_t return_size = hal_dsi_rx_ctrl_get_max_ret_size(g_rx_ctrl_handle);
		hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
		                             DSI_ACK_DT_DSC_SHORT_RESPONSE_1B,
		                             DSI_VC_0,
		                             1, 0);
		TAU_LOGD("r[%x] [%d] err!!!!!!\n", dcs_cmd, return_size);
	}

	//TAU_LOGD("r %x\n",dcs_cmd);
	return true;
}


/* PPS update callback ڷֱлcase */
static bool pps_update_handle(uint8_t *pps, uint8_t size, uint32_t pic_width, uint32_t pic_height)
{
	/* AVDD ϵ, ڽϢPPS */
//	hal_gpio_set_output_data(IO_PAD_PWMEN, IO_LVL_HIGH);
//	hal_dsi_rx_ctrl_set_sw_tear_mode(g_rx_ctrl_handle);
	if (pic_width != g_rx_ctrl_handle->base_info.src_w || pic_height != g_rx_ctrl_handle->base_info.src_h)
	{
		/* PPS Update ҷֱʷ仯 */
		g_rx_ctrl_handle->base_info.src_w = pic_width;
		g_rx_ctrl_handle->base_info.src_h = pic_height;
		/* עⲿֻPPSǰ Compression Mode Command */
		g_rx_ctrl_handle->compress_en = true;
		
		g_resolution_change = true;
		if(pic_width > 720)
		{
			g_tx_ctrl_handle->base_info.src_w = pic_width;
			g_tx_ctrl_handle->base_info.src_h = pic_height;
		}
		hal_dsi_rx_ctrl_toggle_resolution(g_rx_ctrl_handle);
	}
//	hal_dsi_rx_ctrl_set_hw_tear_mode(g_rx_ctrl_handle);
	//    TAU_LOGD("PPS Update\n");
	return true;
}

static bool ap_update_frame_rate(hal_dsi_rx_ctrl_handle_t *handler, hal_dcs_packet_t *dcs_packet)
{
	static uint8_t frame_rate = 0;      //ÿλʱĻʾ60hzǶȡframe_rateȴ
	//TAU_LOGD("frame_rate:[%02X], %d", dcs_packet->packet_param[0], dcs_packet->param_length);
	if (frame_rate != dcs_packet->packet_param[0])
	{
		frame_rate = dcs_packet->packet_param[0];
		if (frame_rate == 0x00)    //120hz
		{

			hal_dsi_rx_ctrl_set_tear_mode_ex(g_rx_ctrl_handle, SYNC_LIN_NUMBER, TE_SOFT_120HZ_MODE);
//            hal_dsi_rx_ctrl_set_tear_mode_ex(g_rx_ctrl_handle, SYNC_LIN_NUMBER, TE_HW_MODE);
			TAU_LOGD("120HZ\n");
		}
		else
		{
			//hal_dsi_rx_ctrl_set_tear_mode_ex(g_rx_ctrl_handle, SYNC_LIN_NUMBER, TE_SOFT_60HZ_MODE);
			hal_dsi_rx_ctrl_set_tear_mode_ex(g_rx_ctrl_handle, SYNC_LIN_NUMBER, TE_HW_MODE);
			TAU_LOGD("60HZ\n");

		}
		//TAU_LOGD("frame_rate:%x",frame_rate);
	}
	return true;
}


  uint8_t pps_fhd[128] = {0x11,0x00,0x00,0x89,0x30,0x80,0x09,0x24,0x04,0x38,0x00,0x4E,0x02,0x1C,0x02,0x1C,
							0x02,0x00,0x02,0x0E,0x00,0x20,0x07,0x93,0x00,0x07,0x00,0x0C,0x01,0x40,0x01,0x4E,
							0x18,0x00,0x10,0xF0,0x03,0x0C,0x20,0x00,0x06,0x0B,0x0B,0x33,0x0E,0x1C,0x2A,0x38,
							0x46,0x54,0x62,0x69,0x70,0x77,0x79,0x7B,0x7D,0x7E,0x01,0x02,0x01,0x00,0x09,0x40,
							0x09,0xBE,0x19,0xFC,0x19,0xFA,0x19,0xF8,0x1A,0x38,0x1A,0x78,0x1A,0xB6,0x2A,0xF6,
							0x2B,0x34,0x2B,0x74,0x3B,0x74,0x6B,0xF4,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
							0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
							0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};


static bool ap_set_display_on(hal_dsi_rx_ctrl_handle_t *handler, hal_dcs_packet_t *dcs_packet)
{
	TAU_LOGD("disp on");
	if(g_resolution_change)
		{
			hal_dsi_rx_ctrl_pre_init_pps(g_rx_ctrl_handle, pps_fhd, 128);
			hal_dsi_rx_ctrl_toggle_resolution(g_rx_ctrl_handle);
			g_resolution_change = false;
			TAU_LOGD("pps_update_1\r\n");	
		}
		delayMs(5);
	if (start_display_on == false){
		hal_dsi_tx_ctrl_write_cmd(0x05, 0, 2, 0x29);
	}
//	g_set_display_on = true;
	return true;
}

static bool ap_set_display_off(hal_dsi_rx_ctrl_handle_t *handler, hal_dcs_packet_t *dcs_packet)
{
	hal_dsi_tx_ctrl_write_cmd(0x05, 0, 1, 0x28);
	TAU_LOGD("disp off");
	return true;
}


static bool ap_set_enter_sleep_mode(hal_dsi_rx_ctrl_handle_t *handler, hal_dcs_packet_t *dcs_packet)
{
	send_29_flag = 0;

	hal_dsi_rx_ctrl_set_sw_tear_mode(g_rx_ctrl_handle);
	delayMs(10);
	Gpio_swire_output(0, 0);
	delayMs(10);
	hal_dsi_tx_ctrl_write_cmd(0x05, 0, 1, 0x10);
	delayMs(20);
	hal_gpio_set_output_data(IO_PAD_PWMEN, IO_LVL_LOW);

	hal_dsi_tx_ctrl_panel_reset_pin(IO_LVL_LOW);//Reaet

	TAU_LOGD("enter sleep mode");
#if ENABLE_TP_WAKE_UP
	g_need_enter_sleep_mode = true;
#endif
	g_exit_sleep_mode = false;

	return true;
}

static bool ap_set_exit_sleep_mode(hal_dsi_rx_ctrl_handle_t *handler, hal_dcs_packet_t *dcs_packet)
{
	TAU_LOGD("exit sleep mode");
	g_exit_sleep_mode = true;
	/* AVDD ϵ, ڽϢPPS */
//    hal_gpio_set_output_data(IO_PAD_PWMEN, IO_LVL_HIGH);
	return true;
}

#ifdef ADD_PWM_OUTPUT_FOR_BL
/*****************************************************************************
*GPIOswire
*flag:  =0, SWIRE=0;  =1,SWIREź; =2, øٷSWIREź
*num: 
*עFLAG=1ʱGPIOʼ!!!!!!
*****************************************************************************/
void Gpio_swire_output(uint8_t flag, uint8_t num)
{
	uint8_t ii;

	if (flag)
	{
		if (flag == 2)
		{
			hal_gpio_init_output(IO_PAD_ADCIN, IO_LVL_HIGH);
			delayMs(2);
		}
		for (ii = 0; ii < num; ii++)
		{
			hal_gpio_set_output_data(IO_PAD_ADCIN, IO_LVL_LOW);
			delayUs(10);
			hal_gpio_set_output_data(IO_PAD_ADCIN, IO_LVL_HIGH);
			delayUs(9);
		}
	}
	else
	{
		hal_gpio_init_output(IO_PAD_ADCIN, IO_LVL_LOW);
	}
}


/*****************************************************************************
* @brief  pwmԿƱ
* @param  init:     ǷΪʼһαѡʼ
* @param  polarity: ԣfalse:ȸߺͣtrue:ȵͺ
* @param  duty_ratio: ռձ(0-100)
* @param  frequency: ƵʣλHZ
* @retval null
*****************************************************************************/
static void test_pwm_out_adjust(bool init, bool polarity, uint8_t duty_ratio, uint32_t frequency)
{
	pwm_out_ctrl_e ctl0 = PWMO_CTRL_HIGH;
	pwm_out_ctrl_e ctl1 = PWMO_CTRL_LOW;
	if (polarity)
	{
		ctl0 = PWMO_CTRL_LOW;
		ctl1 = PWMO_CTRL_HIGH;
	}
	uint32_t period = 1000000 / frequency; //λus
	uint32_t thr0 = 0;
	uint32_t thr1 = (period * duty_ratio / 100);

	if (duty_ratio == 100)
	{
		ctl1 = ctl0;
		thr1 = period / 2;
	}
	if (init)
	{
		hal_pwm_out_init();
		hal_pwm_out_config_all(ctl0, ctl1, thr0, thr1, period);
	}
	else
	{
		hal_pwm_out_sync_all(ctl0, ctl1, thr0, thr1, period);
	}
}

void PWM_OUTPUT_TEST(void)
{
	test_pwm_out_adjust(true, true, 30, 20000);
	delayMs(2);
	test_pwm_out_adjust(false, false, 40, 10000);
}

#define PWM_PERIOD     1000   //PWM.λUS
#define PWM_MIN		 8		//Сֵɵ
void PWM_init(void)//static
{
	// 1ms ڳʼ͵ƽ1000
	hal_pwm_out_init();
	hal_pwm_out_config_all(PWMO_CTRL_LOW, PWMO_CTRL_HIGH, 0, PWM_PERIOD, PWM_PERIOD);
}

static __attribute__((unused)) uint16_t read_bl_data = 0;
static __attribute__((unused)) uint16_t read_bl_data_bak = 0;
void PWM_Task(void)
{
	__attribute__((unused)) uint16_t pwm_h;

#ifdef USE_FOR_Google_Pixel6pro

#if AMOLED_NT37701_CSOT667

	// s20: read_bl_data = 1~FD
	__attribute__((unused)) uint8_t reg51_val_h = 0;
	__attribute__((unused)) uint8_t reg51_val_l = 0;
//	if(Flag_blacklight_EN)
	{
		read_bl_data_bak = 0;
		//	hal_pwm_out_sync_thr(0, PWM_PERIOD+1);
//	hal_dsi_tx_ctrl_write_cmd(0x29, 0, 3, 0x51, 0x00, 0x3F);  //Ϣ·رRX,TXԴ󣬲ٷ
		//printf("Flag_blacklight_EN!!!! read_bl_data[%4x] \n", read_bl_data);
		return;
	}
	/*

		if (g_need_enter_sleep_mode)
		{
			//ΪϨʱ
			read_bl_data_bak = 0;
			//	hal_pwm_out_sync_thr(0, PWM_PERIOD-PWM_MIN); //ΪС
	//	hal_dsi_tx_ctrl_write_cmd(0x29, 0, 3, 0x51, 0x00, 0x3F); //Ϣ·رRX,TXԴ󣬲ٷ
	//		printf("tp_sleep_in!!!! read_bl_data[%4x] \n", read_bl_data);
			//	return;
		}

		if(read_bl_data != read_bl_data_bak)
		{


	#if 0
	#if 1//Բ
			if (pwm_h > 700)
				pwm_h = 300 + (pwm_h - 700) * 7 / 3;
			else
				pwm_h = 1 + (pwm_h - 1) * 3 / 7;
	#endif
			if(pwm_h < PWM_MIN)
				pwm_h = PWM_MIN;

			//printf("ok!!!! read_bl_data[%4x],pwm_h[%d] \n", read_bl_data, pwm_h);

			if(pwm_h < PWM_PERIOD)
				pwm_h = PWM_PERIOD - pwm_h;
			else
				pwm_h = 1;
			//hal_pwm_out_sync_thr(0, pwm_h);
	#endif

			pwm_h = read_bl_data * 16; //NT37701 51  (0~FFF)

			reg51_val_l = ( uint8_t )pwm_h;
			reg51_val_h = pwm_h >> 8;

	//		hal_dsi_tx_ctrl_write_cmd(0x29, 0, 3, 0x51, reg51_val_h, reg51_val_l);  //0FFF//Ϣ·رRX,TXԴ󣬲ٷ


			read_bl_data_bak = read_bl_data;
		}
	*/


#else
// s20: read_bl_data = 1~FD

	if(Flag_blacklight_EN)
	{
		read_bl_data_bak = 0;
		hal_pwm_out_sync_thr(0, PWM_PERIOD + 1);
		//printf("Flag_blacklight_EN!!!! read_bl_data[%4x] \n", read_bl_data);
		return;
	}

	if (g_need_enter_sleep_mode)
	{
		//ΪϨʱ
		read_bl_data_bak = 0;
		hal_pwm_out_sync_thr(0, PWM_PERIOD - PWM_MIN); //ΪС
//		printf("tp_sleep_in!!!! read_bl_data[%4x] \n", read_bl_data);
		//	return;
	}

	if(read_bl_data != read_bl_data_bak)
	{
		pwm_h = PWM_PERIOD * read_bl_data / 0xFF;
#if 1//Բ
		if (pwm_h > 700)
			pwm_h = 300 + (pwm_h - 700) * 7 / 3;
		else
			pwm_h = 1 + (pwm_h - 1) * 3 / 7;
#endif
		if(pwm_h < PWM_MIN)
			pwm_h = PWM_MIN;

		//printf("ok!!!! read_bl_data[%4x],pwm_h[%d] \n", read_bl_data, pwm_h);

		if(pwm_h < PWM_PERIOD)
			pwm_h = PWM_PERIOD - pwm_h;
		else
			pwm_h = 1;
		hal_pwm_out_sync_thr(0, pwm_h);
		read_bl_data_bak = read_bl_data;
	}

#endif

#endif

}
#endif

/* B1ص      g_cus_rx_dcs_execute_table Ϊ첽ִУCAͬ*/

uint16_t value_reg_b1 = 0;
uint16_t value_reg_ca = 0;
uint16_t rd_51_value = 0;

//static uint32_t value_reg_b5 =0;
static uint32_t value_reg_df = 0;
static uint8_t value_blue = 0;
static uint8_t blue_flag = 0;
#if 1 //
#define BLUE_MAX			0xF0	//ֵ
#define BLUE_MIN			0x86	//Сֵ
#define BLUE_STEP			10		//ȼ-1
#endif

#if 1//def USE_FOR_SUMSUNG_S20
static __attribute__((unused)) uint32_t s20_power_on_flag = 0;  // >0: Ϊǡʱ
uint16_t value_reg_ca_bak = 0;
uint16_t value_reg_b1_bak = 0;
//#define USE_BL_ADJ6  //֮ǰS20ⷽʽ
#define USE_BL_ADJ7    //ĹS20ⷽʽ
#endif

#if 1 //
static bool ap_set_backlight(hal_dsi_rx_ctrl_handle_t *handler, hal_dcs_packet_t *dcs_packet)
{
	uint16_t rd_51_val, rd_51_val2;

	//ֻ0x04~7FF(2043) ӳ䵽0x6e~7FF(1937),ȥмͻһ
	rd_51_val = dcs_packet->packet_param[0];
	rd_51_val <<= 8;
	rd_51_val |= dcs_packet->packet_param[1];
	rd_51_val2 = (rd_51_val - 0x04) * 1937 / 2043 + 0x6e;

	if (rd_51_val2 < 0x220 && rd_51_val2 > 0x1B3)
	{
		rd_51_val2 = 0x1B3;
	}

	rd_51_value = rd_51_val;

//	TAU_LOGD("51[%04X][%04X]", rd_51_val, rd_51_val2);

	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 3, 0x51, rd_51_val2 >> 8, rd_51_val2 & 0x00FF);

	return true;
}
#endif

bool ap_get_reg_ca(hal_dsi_rx_ctrl_handle_t *handler, hal_dcs_packet_t *dcs_packet)//static
{
	value_reg_ca = (dcs_packet->packet_param[0] << 8) + dcs_packet->packet_param[1];
	//TAU_LOGD("CA[%x]", value_reg_ca);

	return true;
}

#if 0
static bool ap_get_reg_b5(hal_dsi_rx_ctrl_handle_t *handler, hal_dcs_packet_t *dcs_packet)
{
	value_reg_b5 = (dcs_packet->packet_param[3] << 8) + dcs_packet->packet_param[2];
	TAU_LOGD("CA[%4x],B1[%4x],B5[%4x]", value_reg_ca, value_reg_b1, value_reg_b5);

	return true;
}
#endif

#ifdef ADD_PANEL_DISPLAY_MODE
uint8_t panel_mode = 1; 			// DFĴ100:ۿ,01:۹,11:3(ӰԺ/Ƭ/.Ŀǰû)
uint16_t panel_r, panel_g, panel_b; // ¼RGBֵ

#ifdef USE_FOR_SUMSUNG_S9PLUS
#define RATIO_VALUE 2   				 //Żϵ
#else
#define RATIO_VALUE 2   				 //Żϵ
#endif

#endif

bool ap_get_reg_df(hal_dsi_rx_ctrl_handle_t *handler, hal_dcs_packet_t *dcs_packet)//static
{
#ifdef ADD_PANEL_DISPLAY_MODE
	value_reg_df = (dcs_packet->packet_param[35] << 8) + dcs_packet->packet_param[33];
	panel_mode = dcs_packet->packet_param[0];
	panel_r = dcs_packet->packet_param[49];
	panel_g = dcs_packet->packet_param[51];
	panel_b = dcs_packet->packet_param[53];
//	TAU_LOGD("value_reg_df[%4x],panel_mode[%4x],panel_r[%4x],panel_g[%4x],panel_b[%4x]", value_reg_df,panel_mode,panel_r,panel_g,panel_b);

	if (panel_mode == 00)
	{
		//ģʽ

#ifdef USE_FOR_S10_BLUE_MODE
		//panel_r =256-RATIO_VALUE*(0xFF-panel_r);
		//panel_g =256-RATIO_VALUE*(0xFF-panel_g);
		//panel_b =256-RATIO_VALUE*(0xFF-panel_b);
		//	hal_dsi_rx_ctrl_set_cus_pq_gain(g_rx_ctrl_handle,panel_r,panel_g,panel_b);


#else

		value_reg_df = value_reg_df & 0xFF;
		switch(value_reg_df)
		{
			case 0xC1:
			case 0xC3:
				value_blue = BLUE_MIN;
				break;

			case 0xCF:
			case 0xD0:
				value_blue = BLUE_MIN + (BLUE_MAX - BLUE_MIN) / BLUE_STEP;
				break;

			case 0xD8:
				value_blue = BLUE_MIN + (BLUE_MAX - BLUE_MIN) * 2 / BLUE_STEP;
				break;

			case 0xDE:
				value_blue = BLUE_MIN + (BLUE_MAX - BLUE_MIN) * 3 / BLUE_STEP;
				break;

			case 0xE4:
			case 0xE5:
				value_blue = BLUE_MIN + (BLUE_MAX - BLUE_MIN) * 4 / BLUE_STEP;
				break;

			case 0xE9:
			case 0xEA:
				value_blue = BLUE_MIN + (BLUE_MAX - BLUE_MIN) * 5 / BLUE_STEP;
				break;

			case 0xED:
			case 0xEE:
				value_blue = BLUE_MIN + (BLUE_MAX - BLUE_MIN) * 6 / BLUE_STEP;
				break;

			case 0xF1:
			case 0xF2:
				value_blue = BLUE_MIN + (BLUE_MAX - BLUE_MIN) * 7 / BLUE_STEP;
				break;

			case 0xF4:
			case 0xF5:
				value_blue = BLUE_MIN + (BLUE_MAX - BLUE_MIN) * 8 / BLUE_STEP;
				break;

			case 0xF7:
			case 0xF8:
				value_blue = BLUE_MIN + (BLUE_MAX - BLUE_MIN) * 9 / BLUE_STEP;
				break;

			case 0xFA:
				value_blue = BLUE_MAX;
				break;

			default:
			case 0xFF:
				value_blue = 0;
				break;

		}
		hal_dsi_rx_ctrl_set_cus_pq_gain(g_rx_ctrl_handle, 256, 256, 256);
		hal_dsi_tx_ctrl_write_cmd(0x15, 0, 2, 0x84, value_blue);

#endif

	}
	else
	{
#ifndef USE_FOR_S10_BLUE_MODE
		value_blue = 0;
		hal_dsi_tx_ctrl_write_cmd(0x15, 0, 2, 0x84, value_blue);  //ģʽs8+/s9+
#endif

		//һ㣬ЧԡҪݿͻҪϸ

		panel_r = 256 - RATIO_VALUE * (0xFF - panel_r);
		panel_g = 256 - RATIO_VALUE * (0xFF - panel_g);
		panel_b = 256 - RATIO_VALUE * (0xFF - panel_b);
		//hal_dsi_rx_ctrl_set_cus_pq_gain(g_rx_ctrl_handle,panel_r,panel_g,panel_b);
	}

#ifndef USE_FOR_S10_BLUE_MODE
	if (blue_flag == 0)
	{
		blue_flag = 1;
		delayMs(20);
		hal_dsi_tx_ctrl_write_cmd(0x15, 0, 2, 0x84, value_blue);
	}
#endif

#else
	value_reg_df = (dcs_packet->packet_param[35] << 8) + dcs_packet->packet_param[33];

	value_reg_df = value_reg_df & 0xFF;
	switch(value_reg_df)
	{
		case 0xC1:
		case 0xC3:
			value_blue = BLUE_MIN;
			break;

		case 0xCF:
		case 0xD0:
			value_blue = BLUE_MIN + (BLUE_MAX - BLUE_MIN) / BLUE_STEP;
			break;

		case 0xD8:
			value_blue = BLUE_MIN + (BLUE_MAX - BLUE_MIN) * 2 / BLUE_STEP;
			break;

		case 0xDE:
			value_blue = BLUE_MIN + (BLUE_MAX - BLUE_MIN) * 3 / BLUE_STEP;
			break;

		case 0xE4:
		case 0xE5:
			value_blue = BLUE_MIN + (BLUE_MAX - BLUE_MIN) * 4 / BLUE_STEP;
			break;

		case 0xE9:
		case 0xEA:
			value_blue = BLUE_MIN + (BLUE_MAX - BLUE_MIN) * 5 / BLUE_STEP;
			break;

		case 0xED:
		case 0xEE:
			value_blue = BLUE_MIN + (BLUE_MAX - BLUE_MIN) * 6 / BLUE_STEP;
			break;

		case 0xF1:
		case 0xF2:
			value_blue = BLUE_MIN + (BLUE_MAX - BLUE_MIN) * 7 / BLUE_STEP;
			break;

		case 0xF4:
		case 0xF5:
			value_blue = BLUE_MIN + (BLUE_MAX - BLUE_MIN) * 8 / BLUE_STEP;
			break;

		case 0xF7:
		case 0xF8:
			value_blue = BLUE_MIN + (BLUE_MAX - BLUE_MIN) * 9 / BLUE_STEP;
			break;

		case 0xFA:
			value_blue = BLUE_MAX;
			break;

		default:
		case 0xFF:
			value_blue = 0;
			break;

	}

	TAU_LOGD("df[%4x]", value_reg_df);
	hal_dsi_tx_ctrl_write_cmd(0x15, 0, 2, 0x84, value_blue);
	if (blue_flag == 0)
	{
		blue_flag = 1;
		delayMs(20);
		hal_dsi_tx_ctrl_write_cmd(0x15, 0, 2, 0x84, value_blue);
	}
#endif

	return true;
}

static bool ap_set_backlight_B1(hal_dsi_rx_ctrl_handle_t *handler, hal_dcs_packet_t *dcs_packet)
{
	uint8_t value_b1 = 0;

	value_b1 =  dcs_packet->packet_param[0];

//	hal_dsi_tx_ctrl_write_cmd(0x29, 0, 2, 0x53, value_b1);

	if(value_b1 == 0x90)  // ģʽ
	{
		///FPR ON
		//	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 4, 0x87,0x13,0xFF,0x05);
		if(rd_51_value >= 0x400)
		{
			hal_dsi_tx_ctrl_write_cmd(0x39, 0, 4, 0x87, 0x1B, 0xF2, 0x05);
		}
		else if((rd_51_value >= 0x200) && (rd_51_value < 0x400))
		{
			hal_dsi_tx_ctrl_write_cmd(0x39, 0, 4, 0x87, 0x19, 0xF2, 0x05);
		}
		else if((rd_51_value >= 0x70) && (rd_51_value < 0x200))
		{
			hal_dsi_tx_ctrl_write_cmd(0x39, 0, 4, 0x87, 0x16, 0xF2, 0x05);
		}
		else if((rd_51_value >= 0x2F) && (rd_51_value < 0x70))
		{
			hal_dsi_tx_ctrl_write_cmd(0x39, 0, 4, 0x87, 0x13, 0xF2, 0x05);
		}
		else if((rd_51_value >= 0x10) && (rd_51_value < 0x2F))
		{
			hal_dsi_tx_ctrl_write_cmd(0x39, 0, 4, 0x87, 0x12, 0xF2, 0x05);
		}
		else
		{
			hal_dsi_tx_ctrl_write_cmd(0x39, 0, 4, 0x87, 0x11, 0xF2, 0x05);
		}

	}
	else if(value_b1 == 0x00)  // ˳ģʽ
	{
		///FPR OFF
		hal_dsi_tx_ctrl_write_cmd(0x39, 0, 2, 0x6F, 0x02);
		hal_dsi_tx_ctrl_write_cmd(0x39, 0, 2, 0x87, 0x04);
	}

//	TAU_LOGD("B1[%x]", value_b1);
	return true;
}


/* ƻDCS command  */
static const hal_dcs_execute_entry_t g_cus_rx_dcs_execute_table[] =
{
	{DCS_SET_DISPLAY_ON, ap_set_display_on, true},
	{DCS_SET_DISPLAY_OFF, ap_set_display_off, true},
	//{0xDF, ap_get_reg_df, false},  //
	//{0xCA, ap_get_reg_ca, false},  // ⡣ҪB1ܵ
	{0x51, ap_set_backlight, false},
	{0xB1, ap_set_backlight_B1, true},
	{0x60, ap_update_frame_rate, true},
	{DCS_ENTER_SLEEP_MODE, ap_set_enter_sleep_mode, true},
	{DCS_EXIT_SLEEP_MODE, ap_set_exit_sleep_mode, true},
	{0, NULL, false}                        //{0,NULL,false} һ̶ԱΪtableβжϱ׼
};

static void tx_panel_reset(void)
{
#ifdef USE_WL518_INTERNAL_FLASH
	hal_system_share_flash_mode(true);
#endif
	hal_dsi_tx_ctrl_panel_reset_pin(IO_LVL_HIGH);
	delayMs(10);                //10ms
	hal_dsi_tx_ctrl_panel_reset_pin(IO_LVL_LOW);
	delayMs(10);                //10ms
	hal_dsi_tx_ctrl_panel_reset_pin(IO_LVL_HIGH);
	delayMs(10);
}


#if PANEL_INIT_CODE_ARRAY
static void send_panel_init_code(uint32_t size, uint8_t * data)
{
	uint32_t data_offeset = 0;
	uint8_t data_type;
	uint8_t vc;
	uint8_t data_size;
	uint8_t * p_data;

	while(data_offeset < size)
	{
		data_type = data[data_offeset];
		vc = data[data_offeset + 1];
		data_size = data[data_offeset + 2];
		p_data = &data[data_offeset + 3];
		hal_dsi_tx_ctrl_write_array_cmd(data_type, vc, data_size, p_data);
		data_offeset = data_offeset + data_size + 3;
//        delayUs(5);
	}
}

const uint8_t panel_init_code[] =
{

#if AMOLED_NT37701_CSOT667
	0x39, 0, 6, 0xF0, 0x55, 0xAA, 0x52, 0x08, 0x00,
	0x39, 0, 9, 0xBA, 0x02, 0x79, 0x00, 0x14, 0x03, 0x9C, 0x00, 0x01,
	0x39, 0, 2, 0x6F, 0x08,
	0x39, 0, 9, 0xBA, 0x01, 0xAF, 0x00, 0x14, 0x00, 0x1C, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x10,
	0x39, 0, 8, 0xBA, 0x01, 0x66, 0x00, 0x14, 0x00, 0x1C, 0x00,
	0x39, 0, 9, 0xBB, 0x02, 0x79, 0x00, 0x14, 0x03, 0x9C, 0x00, 0x21,
	0x39, 0, 2, 0xB5, 0x84,
	0x39, 0, 2, 0x6F, 0x06,
	0x39, 0, 4, 0xB5, 0x2B, 0x0C, 0x33,
	0x39, 0, 2, 0x6F, 0x0B,
	0x39, 0, 4, 0xB5, 0x2B, 0x23, 0x33,
	0x39, 0, 2, 0x6F, 0x10,
	0x39, 0, 6, 0xB5, 0x0C, 0x0C, 0x0C, 0x0C, 0x0C,
	0x39, 0, 2, 0x6F, 0x01,
	0x39, 0, 2, 0xB6, 0x19,
	0x39, 0, 19, 0xB7, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x87, 0x65, 0x43, 0x32, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x13,
	0x39, 0, 13, 0xB7, 0x00, 0x00, 0x01, 0x13, 0x78, 0x89, 0x9A, 0xAB, 0xBC, 0xCD, 0xDE, 0xEF,
	0x39, 0, 2, 0x6F, 0x1F,
	0x39, 0, 25, 0xB7, 0x08, 0x31, 0x66, 0x8F, 0xF5, 0xC1, 0xC2, 0x33, 0xFF, 0x7F, 0xFF, 0x7F, 0xFF, 0x7F, 0xFF, 0x7F, 0xFF, 0x7F, 0xFF, 0x7F, 0xFF, 0x7F, 0xFF, 0xFF,
	0x39, 0, 3, 0xB2, 0x98, 0x60,
	0x39, 0, 2, 0x6F, 0x09,
	0x39, 0, 2, 0xB2, 0x40,
	0x39, 0, 2, 0x6F, 0x0F,
	0x39, 0, 9, 0xB2, 0x20, 0x20, 0x21, 0xC2, 0x21, 0xC2, 0x2F, 0xFF,
	0x39, 0, 13, 0xB3, 0x00, 0x08, 0x00, 0x1C, 0x00, 0x1C, 0x00, 0x3C, 0x00, 0x3C, 0x00, 0x70,
	0x39, 0, 2, 0x6F, 0x0C,
	0x39, 0, 13, 0xB3, 0x00, 0x70, 0x00, 0xC8, 0x00, 0xC8, 0x01, 0x48, 0x01, 0x48, 0x01, 0xAD,
	0x39, 0, 2, 0x6F, 0x18,
	0x39, 0, 13, 0xB3, 0x01, 0xAD, 0x01, 0xC2, 0x01, 0xC2, 0x01, 0xC2, 0x07, 0xFF, 0x0F, 0xFF,
	0x39, 0, 2, 0x6F, 0x24,
	0x39, 0, 9, 0xB3, 0x01, 0x55, 0x08, 0xCC, 0x08, 0xCC, 0x0F, 0xFF,
	0x39, 0, 2, 0x6F, 0x2C,
	0x39, 0, 15, 0xB3, 0x09, 0x90, 0x08, 0xDC, 0x08, 0x70, 0x08, 0x70, 0x07, 0xC8, 0x07, 0xC8, 0x06, 0xB8,
	0x39, 0, 2, 0x6F, 0x3A,
	0x39, 0, 13, 0xB3, 0x06, 0xB8, 0x04, 0xE8, 0x04, 0xE8, 0x02, 0x48, 0x02, 0x48, 0x00, 0x38,
	0x39, 0, 2, 0x6F, 0x46,
	0x39, 0, 13, 0xB3, 0x00, 0x38, 0x00, 0x38, 0x00, 0x38, 0x00, 0x38, 0x00, 0x38, 0x00, 0x38,
	0x39, 0, 15, 0xB4, 0x0D, 0x10, 0x0C, 0x1C, 0x0B, 0x88, 0x0B, 0x88, 0x0A, 0xA0, 0x0A, 0xA0, 0x09, 0x28,
	0x39, 0, 2, 0x6F, 0x0E,
	0x39, 0, 13, 0xB4, 0x09, 0x28, 0x06, 0xB0, 0x06, 0xB0, 0x03, 0x18, 0x03, 0x18, 0x00, 0x48,
	0x39, 0, 2, 0x6F, 0x1A,
	0x39, 0, 13, 0xB4, 0x00, 0x48, 0x00, 0x48, 0x00, 0x48, 0x00, 0x48, 0x00, 0x48, 0x00, 0x48,
	0x39, 0, 2, 0x6F, 0x26,
	0x39, 0, 11, 0xB4, 0x0D, 0x10, 0x00, 0x48, 0x00, 0x48, 0x00, 0x48, 0x00, 0x48,
	0x39, 0, 2, 0x6F, 0x30,
	0x39, 0, 15, 0xB4, 0x09, 0x90, 0x08, 0xDC, 0x08, 0x70, 0x08, 0x70, 0x07, 0xC8, 0x07, 0xC8, 0x06, 0xB8,
	0x39, 0, 2, 0x6F, 0x3E,
	0x39, 0, 13, 0xB4, 0x06, 0xB8, 0x04, 0xE8, 0x04, 0xE8, 0x02, 0x48, 0x02, 0x48, 0x00, 0x38,
	0x39, 0, 2, 0x6F, 0x4A,
	0x39, 0, 13, 0xB4, 0x00, 0x38, 0x00, 0x38, 0x00, 0x38, 0x00, 0x38, 0x00, 0x38, 0x00, 0x38,
	0x39, 0, 2, 0x6F, 0xAC,
	0x39, 0, 21, 0xB2, 0x0F, 0xFF, 0x0F, 0xFF, 0x08, 0x09, 0x08, 0x6C, 0x08, 0xCA, 0x09, 0x24, 0x09, 0x79, 0x09, 0xCB, 0x0A, 0x1A, 0x0A, 0x66,
	0x39, 0, 2, 0x6F, 0xC0,
	0x39, 0, 21, 0xB2, 0x0A, 0xB0, 0x0A, 0xF7, 0x0B, 0x3D, 0x0B, 0x80, 0x0B, 0xC1, 0x0C, 0x01, 0x0C, 0x40, 0x0C, 0x7C, 0x0C, 0xB8, 0x0C, 0xF2,
	0x39, 0, 2, 0x6F, 0xD4,
	0x39, 0, 21, 0xB2, 0x0D, 0x2B, 0x0D, 0x63, 0x0D, 0x9A, 0x0D, 0xCF, 0x0E, 0x04, 0x0E, 0x38, 0x0E, 0x6B, 0x0E, 0x9D, 0x0E, 0xCF, 0x0E, 0xFF,
	0x39, 0, 2, 0x6F, 0xE8,
	0x39, 0, 11, 0xB2, 0x0F, 0x2F, 0x0F, 0x5E, 0x0F, 0x8D, 0x0F, 0xBB, 0x0F, 0xFF,
	0x39, 0, 2, 0x6F, 0x52,
	0x39, 0, 21, 0xB3, 0x01, 0xC2, 0x01, 0xC3, 0x01, 0xF5, 0x02, 0x27, 0x02, 0x59, 0x02, 0x8B, 0x02, 0xBD, 0x02, 0xEF, 0x03, 0x21, 0x03, 0x53,
	0x39, 0, 2, 0x6F, 0x66,
	0x39, 0, 21, 0xB3, 0x03, 0x84, 0x03, 0xB6, 0x03, 0xE8, 0x04, 0x1A, 0x04, 0x4C, 0x04, 0x7E, 0x04, 0xB0, 0x04, 0xE2, 0x05, 0x14, 0x05, 0x46,
	0x39, 0, 2, 0x6F, 0x7A,
	0x39, 0, 21, 0xB3, 0x05, 0x78, 0x05, 0xA9, 0x05, 0xDB, 0x06, 0x0D, 0x06, 0x3F, 0x06, 0x71, 0x06, 0xA3, 0x06, 0xD5, 0x07, 0x07, 0x07, 0x39,
	0x39, 0, 2, 0x6F, 0x8E,
	0x39, 0, 9, 0xB3, 0x07, 0x6B, 0x07, 0x9D, 0x07, 0xCE, 0x07, 0xFF,
	0x39, 0, 3, 0xB9, 0x00, 0x96,
	0x39, 0, 3, 0xBD, 0x04, 0xB0,
	0x39, 0, 4, 0xC0, 0x76, 0xF3, 0xC1,
	0x39, 0, 2, 0x6F, 0x08,
	0x39, 0, 2, 0xC0, 0x40,
	0x39, 0, 2, 0x6F, 0x09,
	0x39, 0, 3, 0xC0, 0x20, 0x20,
	0x39, 0, 2, 0x6F, 0x02,
	0x39, 0, 7, 0xC1, 0x24, 0x86, 0x00, 0x57, 0x00, 0x45,
	0x39, 0, 2, 0x6F, 0x0A,
	0x39, 0, 3, 0xC1, 0x00, 0x86,
	0x39, 0, 2, 0xC5, 0x05,
	0x39, 0, 2, 0x6F, 0x08,
	0x39, 0, 2, 0xC3, 0x00,
	0x39, 0, 15, 0xC6, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55,
	0x39, 0, 2, 0xCA, 0x12,
	0x39, 0, 2, 0xB9, 0x00,
	0x39, 0, 5, 0xBE, 0x0E, 0x0B, 0x14, 0x13,
	0x39, 0, 2, 0x6F, 0x05,
	0x39, 0, 2, 0xBE, 0x8A,
	0x39, 0, 6, 0xF0, 0x55, 0xAA, 0x52, 0x08, 0x00,
	0x39, 0, 2, 0x6F, 0x2A,
	0x39, 0, 2, 0xD9, 0x43,
	0x39, 0, 6, 0xF0, 0x55, 0xAA, 0x52, 0x08, 0x01,
	0x39, 0, 11, 0xB5, 0x00, 0xB0, 0x00, 0x98, 0x00, 0x98, 0x00, 0xB0, 0x00, 0x98,
	0x39, 0, 11, 0xB6, 0x01, 0x38, 0x00, 0xD0, 0x00, 0xD0, 0x01, 0x38, 0x00, 0xD0,
	0x39, 0, 13, 0xC2, 0x00, 0xB0, 0x01, 0x38, 0x00, 0xB0, 0x01, 0x38, 0x00, 0xB0, 0x01, 0x38,
	0x39, 0, 3, 0xB0, 0x04, 0x04,
	0x39, 0, 3, 0xB3, 0x13, 0x13,
	0x39, 0, 7, 0xB7, 0x1B, 0x1B, 0x1B, 0x1B, 0x1B, 0x1B,
	0x39, 0, 3, 0xB1, 0x08, 0x08,
	0x39, 0, 3, 0xB4, 0x13, 0x13,
	0x39, 0, 8, 0xB8, 0x46, 0x46, 0x46, 0x46, 0x46, 0x46, 0x46,
	0x39, 0, 29, 0xB9, 0x00, 0x1F, 0x00, 0x00, 0x00, 0x1F, 0x00, 0x00, 0x1F, 0x00, 0x00, 0x1F, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 6, 0xBB, 0x03, 0x94, 0x00, 0x19, 0x3C,
	0x39, 0, 2, 0x6F, 0x05,
	0x39, 0, 20, 0xBB, 0x1B, 0x1B, 0x1B, 0x1B, 0x1B, 0x1B, 0x1B, 0x1B, 0x1B, 0x1B, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
	0x39, 0, 2, 0x6F, 0x18,
	0x39, 0, 20, 0xBB, 0x1B, 0x1B, 0x1B, 0x1B, 0x1B, 0x1B, 0x1B, 0x1B, 0x1B, 0x1B, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
	0x39, 0, 2, 0x6F, 0x2B,
	0x39, 0, 20, 0xBB, 0x1B, 0x1B, 0x1B, 0x1B, 0x1B, 0x1B, 0x1B, 0x1B, 0x1B, 0x1B, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
	0x39, 0, 2, 0x6F, 0x3E,
	0x39, 0, 20, 0xBB, 0x1B, 0x1B, 0x1B, 0x1B, 0x1B, 0x1B, 0x1B, 0x1B, 0x1B, 0x1B, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
	0x39, 0, 5, 0xBA, 0x10, 0x10, 0x10, 0x10,
	0x39, 0, 3, 0xC4, 0x80, 0x03,
	0x39, 0, 2, 0xC7, 0x01,
	0x39, 0, 3, 0xCD, 0x05, 0x81,
	0x39, 0, 2, 0xCF, 0x1D,
	0x39, 0, 2, 0x6F, 0x01,
	0x39, 0, 5, 0xCE, 0x00, 0x01, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x09,
	0x39, 0, 2, 0xD2, 0x00,
	0x39, 0, 2, 0x6F, 0x10,
	0x39, 0, 2, 0xD8, 0x0C,
	0x39, 0, 2, 0xD9, 0xAB,
	0x39, 0, 2, 0xD1, 0x07,
	0x39, 0, 2, 0x6F, 0x02,
	0x39, 0, 2, 0xD1, 0x06,
	0x39, 0, 2, 0x6F, 0x05,
	0x39, 0, 2, 0xD1, 0x06,
	0x39, 0, 3, 0xD6, 0x00, 0x40,
	0x39, 0, 6, 0xF0, 0x55, 0xAA, 0x52, 0x08, 0x02,
	0x39, 0, 25, 0xB9, 0x00, 0x04, 0x00, 0x0C, 0x00, 0x14, 0x00, 0x1C, 0x00, 0x2C, 0x00, 0x3C, 0x00, 0x4C, 0x00, 0x5C, 0x00, 0x7C, 0x00, 0x9C, 0x00, 0xBC, 0x00, 0xDC,
	0x39, 0, 25, 0xBA, 0x00, 0xFC, 0x01, 0x3C, 0x01, 0x7C, 0x01, 0xBC, 0x01, 0xFC, 0x02, 0x7C, 0x02, 0xFC, 0x03, 0x7C, 0x03, 0xBC, 0x03, 0xDC, 0x03, 0xFC, 0x03, 0xFF,
	0x39, 0, 2, 0xBC, 0x11,
	0x39, 0, 17, 0xBD, 0x96, 0x00, 0x69, 0x00, 0x00, 0x96, 0x00, 0x69, 0xBB, 0x44, 0x44, 0xBB, 0xEE, 0x11, 0x11, 0xEE,
	0x39, 0, 2, 0xC1, 0x02,
	0x39, 0, 9, 0xC2, 0x19, 0x00, 0x91, 0x00, 0x19, 0x00, 0x91, 0x00,
	0x39, 0, 3, 0xC0, 0x00, 0x00,
	0x39, 0, 2, 0xCE, 0x01,
	0x39, 0, 2, 0xCC, 0x00,

#if 1
	///////////#1_gamma.txt///////////////

	0x39, 0, 6, 0xF0, 0x55, 0xAA, 0x52, 0x08, 0x02,
	0x39, 0, 2, 0xCC, 0x30,
	0x39, 0, 6, 0xF0, 0x55, 0xAA, 0x52, 0x08, 0x02,
	0x39, 0, 2, 0xBF, 0x09,
	0x39, 0, 19, 0xB0, 0x00, 0x00, 0x02, 0x3C, 0x02, 0x8A, 0x02, 0xD8, 0x03, 0x19, 0x03, 0x99, 0x04, 0x02, 0x04, 0x58, 0x04, 0xAC,
	0x39, 0, 19, 0xB1, 0x05, 0x37, 0x05, 0xA7, 0x06, 0x15, 0x06, 0x6F, 0x06, 0xC7, 0x07, 0x5D, 0x07, 0xE1, 0x08, 0x5E, 0x08, 0xD2,
	0x39, 0, 15, 0xB2, 0x09, 0xB8, 0x0A, 0x91, 0x0B, 0x68, 0x0B, 0xD7, 0x0C, 0x12, 0x0C, 0x4A, 0x0C, 0x4A,
	0x39, 0, 19, 0xB3, 0x00, 0x00, 0x01, 0xB0, 0x02, 0x29, 0x02, 0x75, 0x02, 0xB7, 0x03, 0x38, 0x03, 0x98, 0x03, 0xE4, 0x04, 0x2E,
	0x39, 0, 19, 0xB4, 0x04, 0xA4, 0x05, 0x05, 0x05, 0x65, 0x05, 0xB3, 0x06, 0x00, 0x06, 0x7F, 0x06, 0xF5, 0x07, 0x60, 0x07, 0xC1,
	0x39, 0, 15, 0xB5, 0x08, 0x80, 0x09, 0x33, 0x09, 0xE4, 0x0A, 0x38, 0x0A, 0x61, 0x0A, 0x8C, 0x0A, 0x8C,
	0x39, 0, 19, 0xB6, 0x00, 0x00, 0x01, 0xE6, 0x02, 0x6C, 0x02, 0xDC, 0x03, 0x31, 0x03, 0xD7, 0x04, 0x53, 0x04, 0xB4, 0x05, 0x14,
	0x39, 0, 19, 0xB7, 0x05, 0xA4, 0x06, 0x1A, 0x06, 0x8E, 0x06, 0xEF, 0x07, 0x4E, 0x07, 0xEC, 0x08, 0x7D, 0x09, 0x03, 0x09, 0x83,
	0x39, 0, 15, 0xB8, 0x0A, 0x7F, 0x0B, 0x79, 0x0C, 0x72, 0x0C, 0xFB, 0x0D, 0x42, 0x0D, 0x8E, 0x0D, 0x8E,
	0x39, 0, 2, 0xBF, 0x08,
	0x39, 0, 19, 0xB0, 0x00, 0x00, 0x02, 0x90, 0x02, 0xCC, 0x03, 0x08, 0x03, 0x40, 0x03, 0xAD, 0x04, 0x04, 0x04, 0x59, 0x04, 0x9D,
	0x39, 0, 19, 0xB1, 0x05, 0x22, 0x05, 0x8D, 0x05, 0xEB, 0x06, 0x47, 0x06, 0x96, 0x07, 0x1B, 0x07, 0x9F, 0x08, 0x0F, 0x08, 0x7D,
	0x39, 0, 15, 0xB2, 0x09, 0x42, 0x0A, 0x05, 0x0A, 0xBF, 0x0B, 0x1B, 0x0B, 0x4C, 0x0B, 0x7C, 0x0B, 0x7C,
	0x39, 0, 19, 0xB3, 0x00, 0x00, 0x02, 0x26, 0x02, 0x6E, 0x02, 0x9B, 0x02, 0xD0, 0x03, 0x37, 0x03, 0x86, 0x03, 0xD4, 0x04, 0x0F,
	0x39, 0, 19, 0xB4, 0x04, 0x81, 0x04, 0xDF, 0x05, 0x2F, 0x05, 0x7E, 0x05, 0xC1, 0x06, 0x36, 0x06, 0xA9, 0x07, 0x0B, 0x07, 0x6C,
	0x39, 0, 15, 0xB5, 0x08, 0x10, 0x08, 0xB2, 0x09, 0x4E, 0x09, 0x9A, 0x09, 0xC0, 0x09, 0xE7, 0x09, 0xE7,
	0x39, 0, 19, 0xB6, 0x00, 0x00, 0x02, 0x45, 0x02, 0xA6, 0x02, 0xF7, 0x03, 0x44, 0x03, 0xDB, 0x04, 0x45, 0x04, 0xAE, 0x04, 0xF9,
	0x39, 0, 19, 0xB7, 0x05, 0x8C, 0x06, 0x02, 0x06, 0x64, 0x06, 0xC4, 0x07, 0x16, 0x07, 0xA3, 0x08, 0x2F, 0x08, 0xAC, 0x09, 0x27,
	0x39, 0, 15, 0xB8, 0x0A, 0x00, 0x0A, 0xD8, 0x0B, 0xAD, 0x0C, 0x16, 0x0C, 0x4D, 0x0C, 0x87, 0x0C, 0x87,
	0x39, 0, 2, 0xBF, 0x07,
	0x39, 0, 19, 0xB0, 0x00, 0x00, 0x02, 0x76, 0x02, 0x92, 0x02, 0xAE, 0x02, 0xCA, 0x03, 0x06, 0x03, 0x45, 0x03, 0x7C, 0x03, 0xAF,
	0x39, 0, 19, 0xB1, 0x04, 0x0F, 0x04, 0x5F, 0x04, 0xAD, 0x04, 0xF1, 0x05, 0x2E, 0x05, 0x97, 0x05, 0xF8, 0x06, 0x4F, 0x06, 0x9E,
	0x39, 0, 15, 0xB2, 0x07, 0x2A, 0x07, 0xA6, 0x08, 0x19, 0x08, 0x4E, 0x08, 0x68, 0x08, 0x82, 0x08, 0x82,
	0x39, 0, 19, 0xB3, 0x00, 0x00, 0x02, 0x24, 0x02, 0x42, 0x02, 0x60, 0x02, 0x73, 0x02, 0x9F, 0x02, 0xD4, 0x03, 0x08, 0x03, 0x3A,
	0x39, 0, 19, 0xB4, 0x03, 0x8E, 0x03, 0xD6, 0x04, 0x1C, 0x04, 0x55, 0x04, 0x8A, 0x04, 0xE8, 0x05, 0x3B, 0x05, 0x85, 0x05, 0xCC,
	0x39, 0, 15, 0xB5, 0x06, 0x43, 0x06, 0xAF, 0x07, 0x12, 0x07, 0x41, 0x07, 0x57, 0x07, 0x6C, 0x07, 0x6C,
	0x39, 0, 19, 0xB6, 0x00, 0x00, 0x02, 0x39, 0x02, 0x64, 0x02, 0x8F, 0x02, 0xB3, 0x03, 0x04, 0x03, 0x58, 0x03, 0xA2, 0x03, 0xE4,
	0x39, 0, 19, 0xB7, 0x04, 0x57, 0x04, 0xB5, 0x05, 0x0D, 0x05, 0x55, 0x05, 0x97, 0x06, 0x0A, 0x06, 0x70, 0x06, 0xC9, 0x07, 0x21,
	0x39, 0, 15, 0xB8, 0x07, 0xB2, 0x08, 0x38, 0x08, 0xB3, 0x08, 0xED, 0x09, 0x0A, 0x09, 0x26, 0x09, 0x26,
	0x39, 0, 2, 0xBF, 0x06,
	0x39, 0, 19, 0xB0, 0x00, 0x00, 0x02, 0x6D, 0x02, 0x8B, 0x02, 0xA9, 0x02, 0xC7, 0x03, 0x03, 0x03, 0x3C, 0x03, 0x74, 0x03, 0xA8,
	0x39, 0, 19, 0xB1, 0x04, 0x05, 0x04, 0x53, 0x04, 0xA0, 0x04, 0xE3, 0x05, 0x1B, 0x05, 0x87, 0x05, 0xEB, 0x06, 0x40, 0x06, 0x94,
	0x39, 0, 15, 0xB2, 0x07, 0x1E, 0x07, 0x98, 0x08, 0x06, 0x08, 0x3D, 0x08, 0x57, 0x08, 0x72, 0x08, 0x72,
	0x39, 0, 19, 0xB3, 0x00, 0x00, 0x02, 0x29, 0x02, 0x44, 0x02, 0x5F, 0x02, 0x70, 0x02, 0x9C, 0x02, 0xD0, 0x03, 0x03, 0x03, 0x36,
	0x39, 0, 19, 0xB4, 0x03, 0x87, 0x03, 0xCB, 0x04, 0x0D, 0x04, 0x48, 0x04, 0x79, 0x04, 0xD9, 0x05, 0x2F, 0x05, 0x78, 0x05, 0xBF,
	0x39, 0, 15, 0xB5, 0x06, 0x37, 0x06, 0xA1, 0x07, 0x02, 0x07, 0x31, 0x07, 0x47, 0x07, 0x5D, 0x07, 0x5D,
	0x39, 0, 19, 0xB6, 0x00, 0x00, 0x02, 0x39, 0x02, 0x63, 0x02, 0x8D, 0x02, 0xB0, 0x03, 0x00, 0x03, 0x4D, 0x03, 0x98, 0x03, 0xDE,
	0x39, 0, 19, 0xB7, 0x04, 0x4D, 0x04, 0xA6, 0x04, 0xFE, 0x05, 0x45, 0x05, 0x82, 0x05, 0xF9, 0x06, 0x62, 0x06, 0xBC, 0x07, 0x15,
	0x39, 0, 15, 0xB8, 0x07, 0xA5, 0x08, 0x28, 0x08, 0x9F, 0x08, 0xDA, 0x08, 0xF6, 0x09, 0x11, 0x09, 0x11,
	0x39, 0, 2, 0xBF, 0x05,
	0x39, 0, 19, 0xB0, 0x00, 0x00, 0x02, 0x98, 0x02, 0xAE, 0x02, 0xC4, 0x02, 0xDA, 0x03, 0x10, 0x03, 0x44, 0x03, 0x77, 0x03, 0xA8,
	0x39, 0, 19, 0xB1, 0x04, 0x07, 0x04, 0x5C, 0x04, 0xA5, 0x04, 0xE6, 0x05, 0x1B, 0x05, 0x81, 0x05, 0xE5, 0x06, 0x36, 0x06, 0x86,
	0x39, 0, 15, 0xB2, 0x07, 0x12, 0x07, 0x89, 0x07, 0xF7, 0x08, 0x2D, 0x08, 0x48, 0x08, 0x60, 0x08, 0x60,
	0x39, 0, 19, 0xB3, 0x00, 0x00, 0x02, 0x41, 0x02, 0x59, 0x02, 0x71, 0x02, 0x80, 0x02, 0xA7, 0x02, 0xD6, 0x03, 0x03, 0x03, 0x30,
	0x39, 0, 19, 0xB4, 0x03, 0x87, 0x03, 0xD2, 0x04, 0x11, 0x04, 0x4B, 0x04, 0x7D, 0x04, 0xD5, 0x05, 0x2B, 0x05, 0x72, 0x05, 0xB7,
	0x39, 0, 15, 0xB5, 0x06, 0x2F, 0x06, 0x98, 0x06, 0xF7, 0x07, 0x25, 0x07, 0x3C, 0x07, 0x51, 0x07, 0x51,
	0x39, 0, 19, 0xB6, 0x00, 0x00, 0x02, 0x54, 0x02, 0x79, 0x02, 0x9E, 0x02, 0xBD, 0x03, 0x06, 0x03, 0x4E, 0x03, 0x94, 0x03, 0xD2,
	0x39, 0, 19, 0xB7, 0x04, 0x4B, 0x04, 0xAD, 0x04, 0xFF, 0x05, 0x48, 0x05, 0x84, 0x05, 0xF1, 0x06, 0x5D, 0x06, 0xB4, 0x07, 0x09,
	0x39, 0, 15, 0xB8, 0x07, 0x9C, 0x08, 0x1D, 0x08, 0x92, 0x08, 0xCB, 0x08, 0xE7, 0x09, 0x02, 0x09, 0x02,
	0x39, 0, 2, 0xBF, 0x04,
	0x39, 0, 19, 0xB0, 0x00, 0x00, 0x02, 0xA2, 0x02, 0xB9, 0x02, 0xD0, 0x02, 0xE7, 0x03, 0x18, 0x03, 0x4B, 0x03, 0x7D, 0x03, 0xB2,
	0x39, 0, 19, 0xB1, 0x04, 0x03, 0x04, 0x53, 0x04, 0x95, 0x04, 0xD6, 0x05, 0x11, 0x05, 0x7A, 0x05, 0xDC, 0x06, 0x2D, 0x06, 0x7D,
	0x39, 0, 15, 0xB2, 0x07, 0x01, 0x07, 0x77, 0x07, 0xE4, 0x08, 0x18, 0x08, 0x31, 0x08, 0x49, 0x08, 0x49,
	0x39, 0, 19, 0xB3, 0x00, 0x00, 0x02, 0x65, 0x02, 0x79, 0x02, 0x8D, 0x02, 0x9A, 0x02, 0xC0, 0x02, 0xEC, 0x03, 0x16, 0x03, 0x45,
	0x39, 0, 19, 0xB4, 0x03, 0x90, 0x03, 0xDA, 0x04, 0x15, 0x04, 0x4E, 0x04, 0x83, 0x04, 0xDF, 0x05, 0x31, 0x05, 0x77, 0x05, 0xBB,
	0x39, 0, 15, 0xB5, 0x06, 0x31, 0x06, 0x98, 0x06, 0xF7, 0x07, 0x23, 0x07, 0x38, 0x07, 0x4C, 0x07, 0x4C,
	0x39, 0, 19, 0xB6, 0x00, 0x00, 0x02, 0x7A, 0x02, 0x96, 0x02, 0xB2, 0x02, 0xCA, 0x03, 0x10, 0x03, 0x55, 0x03, 0x99, 0x03, 0xDC,
	0x39, 0, 19, 0xB7, 0x04, 0x40, 0x04, 0xA2, 0x04, 0xEE, 0x05, 0x38, 0x05, 0x79, 0x05, 0xEE, 0x06, 0x54, 0x06, 0xA9, 0x06, 0xFC,
	0x39, 0, 15, 0xB8, 0x07, 0x8A, 0x08, 0x09, 0x08, 0x80, 0x08, 0xB8, 0x08, 0xD2, 0x08, 0xEC, 0x08, 0xEC,
	0x39, 0, 2, 0xBF, 0x03,
	0x39, 0, 19, 0xB0, 0x00, 0x00, 0x02, 0xEA, 0x02, 0xFB, 0x03, 0x0C, 0x03, 0x1D, 0x03, 0x40, 0x03, 0x6C, 0x03, 0x96, 0x03, 0xBE,
	0x39, 0, 19, 0xB1, 0x04, 0x0D, 0x04, 0x52, 0x04, 0x91, 0x04, 0xCF, 0x05, 0x06, 0x05, 0x6A, 0x05, 0xC3, 0x06, 0x13, 0x06, 0x62,
	0x39, 0, 15, 0xB2, 0x06, 0xE5, 0x07, 0x59, 0x07, 0xC0, 0x07, 0xF2, 0x08, 0x0A, 0x08, 0x21, 0x08, 0x21,
	0x39, 0, 19, 0xB3, 0x00, 0x00, 0x02, 0x95, 0x02, 0xAA, 0x02, 0xBF, 0x02, 0xD4, 0x02, 0xEF, 0x03, 0x11, 0x03, 0x34, 0x03, 0x55,
	0x39, 0, 19, 0xB4, 0x03, 0x9E, 0x03, 0xDD, 0x04, 0x15, 0x04, 0x4B, 0x04, 0x7D, 0x04, 0xD5, 0x05, 0x21, 0x05, 0x66, 0x05, 0xAA,
	0x39, 0, 15, 0xB5, 0x06, 0x19, 0x06, 0x7D, 0x06, 0xD7, 0x07, 0x03, 0x07, 0x17, 0x07, 0x2B, 0x07, 0x2B,
	0x39, 0, 19, 0xB6, 0x00, 0x00, 0x02, 0xA4, 0x02, 0xC2, 0x02, 0xE0, 0x02, 0xFE, 0x03, 0x31, 0x03, 0x6C, 0x03, 0xA3, 0x03, 0xD8,
	0x39, 0, 19, 0xB7, 0x04, 0x40, 0x04, 0x95, 0x04, 0xE0, 0x05, 0x29, 0x05, 0x69, 0x05, 0xD8, 0x06, 0x38, 0x06, 0x8E, 0x06, 0xE2,
	0x39, 0, 15, 0xB8, 0x07, 0x6D, 0x07, 0xE8, 0x08, 0x58, 0x08, 0x8E, 0x08, 0xA8, 0x08, 0xC1, 0x08, 0xC1,
	0x39, 0, 2, 0xBF, 0x02,
	0x39, 0, 19, 0xB0, 0x00, 0x00, 0x03, 0x24, 0x03, 0x34, 0x03, 0x44, 0x03, 0x54, 0x03, 0x74, 0x03, 0x94, 0x03, 0xB4, 0x03, 0xD3,
	0x39, 0, 19, 0xB1, 0x04, 0x16, 0x04, 0x53, 0x04, 0x8B, 0x04, 0xC1, 0x04, 0xF2, 0x05, 0x51, 0x05, 0xA7, 0x05, 0xF2, 0x06, 0x3E,
	0x39, 0, 15, 0xB2, 0x06, 0xB9, 0x07, 0x26, 0x07, 0x8E, 0x07, 0xBE, 0x07, 0xD4, 0x07, 0xEA, 0x07, 0xEA,
	0x39, 0, 19, 0xB3, 0x00, 0x00, 0x02, 0xB7, 0x02, 0xCD, 0x02, 0xE3, 0x02, 0xF9, 0x03, 0x25, 0x03, 0x41, 0x03, 0x5B, 0x03, 0x74,
	0x39, 0, 19, 0xB4, 0x03, 0xAD, 0x03, 0xE8, 0x04, 0x19, 0x04, 0x49, 0x04, 0x73, 0x04, 0xC4, 0x05, 0x11, 0x05, 0x50, 0x05, 0x8C,
	0x39, 0, 15, 0xB5, 0x05, 0xF9, 0x06, 0x57, 0x06, 0xAE, 0x06, 0xD7, 0x06, 0xEA, 0x06, 0xFD, 0x06, 0xFD,
	0x39, 0, 19, 0xB6, 0x00, 0x00, 0x02, 0xC9, 0x02, 0xE5, 0x03, 0x01, 0x03, 0x1D, 0x03, 0x56, 0x03, 0x86, 0x03, 0xB3, 0x03, 0xDE,
	0x39, 0, 19, 0xB7, 0x04, 0x37, 0x04, 0x8A, 0x04, 0xCF, 0x05, 0x12, 0x05, 0x4A, 0x05, 0xB8, 0x06, 0x1A, 0x06, 0x6B, 0x06, 0xB9,
	0x39, 0, 15, 0xB8, 0x07, 0x3F, 0x07, 0xB6, 0x08, 0x23, 0x08, 0x56, 0x08, 0x6E, 0x08, 0x86, 0x08, 0x86,
	0x39, 0, 2, 0xBF, 0x01,
	0x39, 0, 19, 0xB0, 0x00, 0x00, 0x03, 0x6F, 0x03, 0x7A, 0x03, 0x85, 0x03, 0x90, 0x03, 0xA7, 0x03, 0xBE, 0x03, 0xD5, 0x03, 0xEE,
	0x39, 0, 19, 0xB1, 0x04, 0x1E, 0x04, 0x4F, 0x04, 0x7E, 0x04, 0xAD, 0x04, 0xD8, 0x05, 0x2A, 0x05, 0x71, 0x05, 0xB7, 0x05, 0xFA,
	0x39, 0, 15, 0xB2, 0x06, 0x70, 0x06, 0xDB, 0x07, 0x38, 0x07, 0x65, 0x07, 0x7B, 0x07, 0x8F, 0x07, 0x8F,
	0x39, 0, 19, 0xB3, 0x00, 0x00, 0x03, 0x20, 0x03, 0x2D, 0x03, 0x3A, 0x03, 0x47, 0x03, 0x62, 0x03, 0x7D, 0x03, 0x8E, 0x03, 0xA2,
	0x39, 0, 19, 0xB4, 0x03, 0xC7, 0x03, 0xEE, 0x04, 0x17, 0x04, 0x3E, 0x04, 0x64, 0x04, 0xAC, 0x04, 0xE9, 0x05, 0x24, 0x05, 0x5B,
	0x39, 0, 15, 0xB5, 0x05, 0xBD, 0x06, 0x17, 0x06, 0x66, 0x06, 0x8C, 0x06, 0x9F, 0x06, 0xB1, 0x06, 0xB1,
	0x39, 0, 19, 0xB6, 0x00, 0x00, 0x03, 0x2E, 0x03, 0x40, 0x03, 0x52, 0x03, 0x64, 0x03, 0x88, 0x03, 0xAC, 0x03, 0xCA, 0x03, 0xED,
	0x39, 0, 19, 0xB7, 0x04, 0x2F, 0x04, 0x6D, 0x04, 0xAD, 0x04, 0xE8, 0x05, 0x1D, 0x05, 0x83, 0x05, 0xD5, 0x06, 0x25, 0x06, 0x6F,
	0x39, 0, 15, 0xB8, 0x06, 0xF0, 0x07, 0x63, 0x07, 0xC5, 0x07, 0xF5, 0x08, 0x0D, 0x08, 0x23, 0x08, 0x23,
	0x39, 0, 2, 0xBF, 0x00,
	0x39, 0, 19, 0xB0, 0x00, 0x00, 0x03, 0xBE, 0x03, 0xC4, 0x03, 0xCA, 0x03, 0xD0, 0x03, 0xDD, 0x03, 0xEA, 0x03, 0xF7, 0x04, 0x04,
	0x39, 0, 19, 0xB1, 0x04, 0x1F, 0x04, 0x3C, 0x04, 0x58, 0x04, 0x77, 0x04, 0x94, 0x04, 0xCD, 0x05, 0x03, 0x05, 0x37, 0x05, 0x69,
	0x39, 0, 15, 0xB2, 0x05, 0xC6, 0x06, 0x18, 0x06, 0x69, 0x06, 0x8F, 0x06, 0xA1, 0x06, 0xB5, 0x06, 0xB5,
	0x39, 0, 19, 0xB3, 0x00, 0x00, 0x03, 0x83, 0x03, 0x8A, 0x03, 0x91, 0x03, 0x98, 0x03, 0xA6, 0x03, 0xB4, 0x03, 0xC2, 0x03, 0xD0,
	0x39, 0, 19, 0xB4, 0x03, 0xE2, 0x03, 0xF8, 0x04, 0x0D, 0x04, 0x26, 0x04, 0x3C, 0x04, 0x6A, 0x04, 0x96, 0x04, 0xC1, 0x04, 0xEB,
	0x39, 0, 15, 0xB5, 0x05, 0x39, 0x05, 0x7D, 0x05, 0xBF, 0x05, 0xDF, 0x05, 0xED, 0x05, 0xFD, 0x05, 0xFD,
	0x39, 0, 19, 0xB6, 0x00, 0x00, 0x03, 0x81, 0x03, 0x8B, 0x03, 0x95, 0x03, 0x9F, 0x03, 0xB4, 0x03, 0xC9, 0x03, 0xDE, 0x03, 0xF3,
	0x39, 0, 19, 0xB7, 0x04, 0x16, 0x04, 0x3E, 0x04, 0x67, 0x04, 0x8F, 0x04, 0xB3, 0x04, 0xFE, 0x05, 0x43, 0x05, 0x83, 0x05, 0xC1,
	0x39, 0, 15, 0xB8, 0x06, 0x2F, 0x06, 0x8B, 0x06, 0xE5, 0x07, 0x0F, 0x07, 0x22, 0x07, 0x35, 0x07, 0x35,
	0x39, 0, 6, 0xF0, 0x55, 0xAA, 0x52, 0x08, 0x02,
	0x39, 0, 2, 0xBF, 0x19,
	0x39, 0, 19, 0xB0, 0x00, 0x00, 0x02, 0x26, 0x02, 0x64, 0x02, 0xA2, 0x02, 0xDB, 0x03, 0x4A, 0x03, 0xB1, 0x04, 0x04, 0x04, 0x55,
	0x39, 0, 19, 0xB1, 0x04, 0xD8, 0x05, 0x46, 0x05, 0xB3, 0x06, 0x0B, 0x06, 0x61, 0x06, 0xFC, 0x07, 0x7F, 0x07, 0xFB, 0x08, 0x6F,
	0x39, 0, 15, 0xB2, 0x09, 0x55, 0x0A, 0x31, 0x0B, 0x0B, 0x0B, 0x7E, 0x0B, 0xBA, 0x0B, 0xF3, 0x0B, 0xF3,
	0x39, 0, 19, 0xB3, 0x00, 0x00, 0x01, 0xC0, 0x02, 0x1B, 0x02, 0x54, 0x02, 0x89, 0x02, 0xF1, 0x03, 0x4D, 0x03, 0x94, 0x03, 0xDA,
	0x39, 0, 19, 0xB4, 0x04, 0x4F, 0x04, 0xAD, 0x05, 0x0A, 0x05, 0x56, 0x05, 0xA1, 0x06, 0x28, 0x06, 0x98, 0x07, 0x03, 0x07, 0x64,
	0x39, 0, 15, 0xB5, 0x08, 0x24, 0x08, 0xD7, 0x09, 0x88, 0x09, 0xE1, 0x0A, 0x0B, 0x0A, 0x35, 0x0A, 0x35,
	0x39, 0, 19, 0xB6, 0x00, 0x00, 0x01, 0xF3, 0x02, 0x57, 0x02, 0xAB, 0x02, 0xF5, 0x03, 0x86, 0x04, 0x00, 0x04, 0x5D, 0x04, 0xB8,
	0x39, 0, 19, 0xB7, 0x05, 0x4A, 0x05, 0xBD, 0x06, 0x2F, 0x06, 0x8D, 0x06, 0xE9, 0x07, 0x92, 0x08, 0x1B, 0x08, 0xA1, 0x09, 0x20,
	0x39, 0, 15, 0xB8, 0x0A, 0x1B, 0x0B, 0x1B, 0x0C, 0x1A, 0x0C, 0xA6, 0x0C, 0xF3, 0x0D, 0x44, 0x0D, 0x44,
	0x39, 0, 2, 0xBF, 0x18,
	0x39, 0, 19, 0xB0, 0x00, 0x00, 0x02, 0x97, 0x02, 0xC2, 0x02, 0xED, 0x03, 0x18, 0x03, 0x6C, 0x03, 0xBA, 0x04, 0x07, 0x04, 0x48,
	0x39, 0, 19, 0xB1, 0x04, 0xC7, 0x05, 0x31, 0x05, 0x8E, 0x05, 0xE9, 0x06, 0x37, 0x06, 0xBA, 0x07, 0x3B, 0x07, 0xAB, 0x08, 0x1A,
	0x39, 0, 15, 0xB2, 0x08, 0xE1, 0x09, 0xA6, 0x0A, 0x62, 0x0A, 0xBE, 0x0A, 0xED, 0x0B, 0x20, 0x0B, 0x20,
	0x39, 0, 19, 0xB3, 0x00, 0x00, 0x02, 0x47, 0x02, 0x77, 0x02, 0x95, 0x02, 0xBA, 0x03, 0x00, 0x03, 0x43, 0x03, 0x84, 0x03, 0xBD,
	0x39, 0, 19, 0xB4, 0x04, 0x2B, 0x04, 0x87, 0x04, 0xD7, 0x05, 0x26, 0x05, 0x68, 0x05, 0xDA, 0x06, 0x4A, 0x06, 0xAB, 0x07, 0x0B,
	0x39, 0, 15, 0xB5, 0x07, 0xAF, 0x08, 0x52, 0x08, 0xEC, 0x09, 0x38, 0x09, 0x60, 0x09, 0x88, 0x09, 0x88,
	0x39, 0, 19, 0xB6, 0x00, 0x00, 0x02, 0x60, 0x02, 0xA5, 0x02, 0xDF, 0x03, 0x1C, 0x03, 0x92, 0x03, 0xF2, 0x04, 0x51, 0x04, 0x9B,
	0x39, 0, 19, 0xB7, 0x05, 0x2C, 0x05, 0x9F, 0x06, 0x02, 0x06, 0x64, 0x06, 0xB7, 0x07, 0x44, 0x07, 0xCF, 0x08, 0x48, 0x08, 0xBF,
	0x39, 0, 15, 0xB8, 0x09, 0x9A, 0x0A, 0x74, 0x0B, 0x51, 0x0B, 0xBE, 0x0B, 0xF5, 0x0C, 0x30, 0x0C, 0x30,
	0x39, 0, 2, 0xBF, 0x17,
	0x39, 0, 19, 0xB0, 0x00, 0x00, 0x02, 0x8B, 0x02, 0x9B, 0x02, 0xAB, 0x02, 0xBB, 0x02, 0xE6, 0x03, 0x16, 0x03, 0x44, 0x03, 0x72,
	0x39, 0, 19, 0xB1, 0x03, 0xC0, 0x04, 0x0C, 0x04, 0x53, 0x04, 0x93, 0x04, 0xCC, 0x05, 0x36, 0x05, 0x97, 0x05, 0xEA, 0x06, 0x3A,
	0x39, 0, 15, 0xB2, 0x06, 0xC6, 0x07, 0x44, 0x07, 0xB6, 0x07, 0xE9, 0x08, 0x04, 0x08, 0x1E, 0x08, 0x1E,
	0x39, 0, 19, 0xB3, 0x00, 0x00, 0x02, 0x3B, 0x02, 0x51, 0x02, 0x67, 0x02, 0x75, 0x02, 0x92, 0x02, 0xB8, 0x02, 0xDD, 0x03, 0x03,
	0x39, 0, 19, 0xB4, 0x03, 0x47, 0x03, 0x88, 0x03, 0xC4, 0x03, 0xFE, 0x04, 0x2E, 0x04, 0x8B, 0x04, 0xE0, 0x05, 0x2A, 0x05, 0x6C,
	0x39, 0, 15, 0xB5, 0x05, 0xE5, 0x06, 0x4C, 0x06, 0xB0, 0x06, 0xDF, 0x06, 0xF6, 0x07, 0x0C, 0x07, 0x0C,
	0x39, 0, 19, 0xB6, 0x00, 0x00, 0x02, 0x55, 0x02, 0x73, 0x02, 0x91, 0x02, 0xAA, 0x02, 0xE3, 0x03, 0x27, 0x03, 0x65, 0x03, 0xA0,
	0x39, 0, 19, 0xB7, 0x04, 0x02, 0x04, 0x5C, 0x04, 0xAC, 0x04, 0xF5, 0x05, 0x34, 0x05, 0xA6, 0x06, 0x0F, 0x06, 0x69, 0x06, 0xBC,
	0x39, 0, 15, 0xB8, 0x07, 0x51, 0x07, 0xD4, 0x08, 0x4F, 0x08, 0x88, 0x08, 0xA6, 0x08, 0xC2, 0x08, 0xC2,
	0x39, 0, 2, 0xBF, 0x16,
	0x39, 0, 19, 0xB0, 0x00, 0x00, 0x02, 0x8E, 0x02, 0x9D, 0x02, 0xAC, 0x02, 0xBB, 0x02, 0xE4, 0x03, 0x11, 0x03, 0x3D, 0x03, 0x68,
	0x39, 0, 19, 0xB1, 0x03, 0xC1, 0x04, 0x08, 0x04, 0x4E, 0x04, 0x8D, 0x04, 0xC3, 0x05, 0x2D, 0x05, 0x8B, 0x05, 0xDC, 0x06, 0x2B,
	0x39, 0, 15, 0xB2, 0x06, 0xB5, 0x07, 0x31, 0x07, 0xA3, 0x07, 0xD8, 0x07, 0xF1, 0x08, 0x0C, 0x08, 0x0C,
	0x39, 0, 19, 0xB3, 0x00, 0x00, 0x02, 0x3F, 0x02, 0x53, 0x02, 0x67, 0x02, 0x74, 0x02, 0x91, 0x02, 0xB5, 0x02, 0xD7, 0x02, 0xFB,
	0x39, 0, 19, 0xB4, 0x03, 0x46, 0x03, 0x84, 0x03, 0xC1, 0x03, 0xF8, 0x04, 0x27, 0x04, 0x81, 0x04, 0xD2, 0x05, 0x18, 0x05, 0x5D,
	0x39, 0, 15, 0xB5, 0x05, 0xD6, 0x06, 0x40, 0x06, 0xA3, 0x06, 0xD1, 0x06, 0xE6, 0x06, 0xFD, 0x06, 0xFD,
	0x39, 0, 19, 0xB6, 0x00, 0x00, 0x02, 0x58, 0x02, 0x74, 0x02, 0x90, 0x02, 0xA8, 0x02, 0xE1, 0x03, 0x1F, 0x03, 0x5B, 0x03, 0x93,
	0x39, 0, 19, 0xB7, 0x04, 0x01, 0x04, 0x55, 0x04, 0xA7, 0x04, 0xEE, 0x05, 0x28, 0x05, 0x9A, 0x05, 0xFF, 0x06, 0x55, 0x06, 0xA9,
	0x39, 0, 15, 0xB8, 0x07, 0x3F, 0x07, 0xC2, 0x08, 0x3E, 0x08, 0x77, 0x08, 0x92, 0x08, 0xAF, 0x08, 0xAF,
	0x39, 0, 2, 0xBF, 0x15,
	0x39, 0, 19, 0xB0, 0x00, 0x00, 0x02, 0xA9, 0x02, 0xB8, 0x02, 0xC7, 0x02, 0xD6, 0x02, 0xF7, 0x03, 0x22, 0x03, 0x4C, 0x03, 0x73,
	0x39, 0, 19, 0xB1, 0x03, 0xBF, 0x04, 0x04, 0x04, 0x49, 0x04, 0x88, 0x04, 0xBF, 0x05, 0x22, 0x05, 0x83, 0x05, 0xD4, 0x06, 0x23,
	0x39, 0, 15, 0xB2, 0x06, 0xAE, 0x07, 0x28, 0x07, 0x94, 0x07, 0xC8, 0x07, 0xE4, 0x07, 0xFD, 0x07, 0xFD,
	0x39, 0, 19, 0xB3, 0x00, 0x00, 0x02, 0x52, 0x02, 0x66, 0x02, 0x7A, 0x02, 0x87, 0x02, 0x9F, 0x02, 0xBF, 0x02, 0xDD, 0x03, 0x01,
	0x39, 0, 19, 0xB4, 0x03, 0x45, 0x03, 0x86, 0x03, 0xBF, 0x03, 0xF4, 0x04, 0x27, 0x04, 0x7C, 0x04, 0xD0, 0x05, 0x15, 0x05, 0x58,
	0x39, 0, 15, 0xB5, 0x05, 0xD1, 0x06, 0x38, 0x06, 0x97, 0x06, 0xC5, 0x06, 0xDB, 0x06, 0xF1, 0x06, 0xF1,
	0x39, 0, 19, 0xB6, 0x00, 0x00, 0x02, 0x75, 0x02, 0x8F, 0x02, 0xA9, 0x02, 0xBF, 0x02, 0xEE, 0x03, 0x29, 0x03, 0x62, 0x03, 0x96,
	0x39, 0, 19, 0xB7, 0x03, 0xFC, 0x04, 0x54, 0x04, 0xA2, 0x04, 0xE6, 0x05, 0x26, 0x05, 0x90, 0x05, 0xF9, 0x06, 0x4F, 0x06, 0xA3,
	0x39, 0, 15, 0xB8, 0x07, 0x37, 0x07, 0xB9, 0x08, 0x2F, 0x08, 0x69, 0x08, 0x84, 0x08, 0x9F, 0x08, 0x9F,
	0x39, 0, 2, 0xBF, 0x14,
	0x39, 0, 19, 0xB0, 0x00, 0x00, 0x02, 0xBE, 0x02, 0xC9, 0x02, 0xD4, 0x02, 0xDF, 0x03, 0x00, 0x03, 0x25, 0x03, 0x49, 0x03, 0x6F,
	0x39, 0, 19, 0xB1, 0x03, 0xBA, 0x04, 0x04, 0x04, 0x44, 0x04, 0x82, 0x04, 0xBA, 0x05, 0x20, 0x05, 0x79, 0x05, 0xC9, 0x06, 0x18,
	0x39, 0, 15, 0xB2, 0x06, 0x9E, 0x07, 0x15, 0x07, 0x82, 0x07, 0xB6, 0x07, 0xCE, 0x07, 0xE5, 0x07, 0xE5,
	0x39, 0, 19, 0xB3, 0x00, 0x00, 0x02, 0x6B, 0x02, 0x7E, 0x02, 0x91, 0x02, 0x9D, 0x02, 0xB5, 0x02, 0xD5, 0x02, 0xF3, 0x03, 0x10,
	0x39, 0, 19, 0xB4, 0x03, 0x52, 0x03, 0x93, 0x03, 0xCB, 0x04, 0x01, 0x04, 0x33, 0x04, 0x8A, 0x04, 0xD3, 0x05, 0x18, 0x05, 0x5B,
	0x39, 0, 15, 0xB5, 0x05, 0xCF, 0x06, 0x36, 0x06, 0x95, 0x06, 0xC1, 0x06, 0xD6, 0x06, 0xEA, 0x06, 0xEA,
	0x39, 0, 19, 0xB6, 0x00, 0x00, 0x02, 0x8B, 0x02, 0xA3, 0x02, 0xBB, 0x02, 0xCF, 0x02, 0xFA, 0x03, 0x30, 0x03, 0x64, 0x03, 0x95,
	0x39, 0, 19, 0xB7, 0x03, 0xF3, 0x04, 0x50, 0x04, 0x99, 0x04, 0xE1, 0x05, 0x22, 0x05, 0x92, 0x05, 0xEF, 0x06, 0x43, 0x06, 0x95,
	0x39, 0, 15, 0xB8, 0x07, 0x25, 0x07, 0xA7, 0x08, 0x1E, 0x08, 0x56, 0x08, 0x70, 0x08, 0x89, 0x08, 0x89,
	0x39, 0, 2, 0xBF, 0x13,
	0x39, 0, 19, 0xB0, 0x00, 0x00, 0x02, 0xF5, 0x03, 0x01, 0x03, 0x0D, 0x03, 0x19, 0x03, 0x32, 0x03, 0x50, 0x03, 0x6F, 0x03, 0x8D,
	0x39, 0, 19, 0xB1, 0x03, 0xCC, 0x04, 0x0B, 0x04, 0x45, 0x04, 0x7D, 0x04, 0xB1, 0x05, 0x15, 0x05, 0x6A, 0x05, 0xB4, 0x05, 0xFD,
	0x39, 0, 15, 0xB2, 0x06, 0x82, 0x06, 0xF8, 0x07, 0x5F, 0x07, 0x91, 0x07, 0xA9, 0x07, 0xBF, 0x07, 0xBF,
	0x39, 0, 19, 0xB3, 0x00, 0x00, 0x02, 0xA6, 0x02, 0xB7, 0x02, 0xC8, 0x02, 0xD9, 0x02, 0xEF, 0x03, 0x05, 0x03, 0x1F, 0x03, 0x38,
	0x39, 0, 19, 0xB4, 0x03, 0x6C, 0x03, 0xA1, 0x03, 0xD4, 0x04, 0x05, 0x04, 0x30, 0x04, 0x86, 0x04, 0xCF, 0x05, 0x10, 0x05, 0x4F,
	0x39, 0, 15, 0xB5, 0x05, 0xBF, 0x06, 0x20, 0x06, 0x7A, 0x06, 0xA5, 0x06, 0xB9, 0x06, 0xCC, 0x06, 0xCC,
	0x39, 0, 19, 0xB6, 0x00, 0x00, 0x02, 0xC9, 0x02, 0xDE, 0x02, 0xF3, 0x03, 0x08, 0x03, 0x2C, 0x03, 0x55, 0x03, 0x81, 0x03, 0xAC,
	0x39, 0, 19, 0xB7, 0x03, 0xFD, 0x04, 0x4C, 0x04, 0x91, 0x04, 0xD5, 0x05, 0x10, 0x05, 0x80, 0x05, 0xDF, 0x06, 0x2F, 0x06, 0x7D,
	0x39, 0, 15, 0xB8, 0x07, 0x0C, 0x07, 0x8A, 0x07, 0xF9, 0x08, 0x2F, 0x08, 0x48, 0x08, 0x61, 0x08, 0x61,
	0x39, 0, 2, 0xBF, 0x12,
	0x39, 0, 19, 0xB0, 0x00, 0x00, 0x03, 0x33, 0x03, 0x3E, 0x03, 0x49, 0x03, 0x54, 0x03, 0x6A, 0x03, 0x80, 0x03, 0x97, 0x03, 0xAD,
	0x39, 0, 19, 0xB1, 0x03, 0xE1, 0x04, 0x13, 0x04, 0x47, 0x04, 0x79, 0x04, 0xA6, 0x04, 0xFE, 0x05, 0x4E, 0x05, 0x99, 0x05, 0xDE,
	0x39, 0, 15, 0xB2, 0x06, 0x58, 0x06, 0xC7, 0x07, 0x2B, 0x07, 0x5B, 0x07, 0x71, 0x07, 0x88, 0x07, 0x88,
	0x39, 0, 19, 0xB3, 0x00, 0x00, 0x02, 0xE6, 0x02, 0xF4, 0x03, 0x02, 0x03, 0x10, 0x03, 0x2C, 0x03, 0x3E, 0x03, 0x51, 0x03, 0x62,
	0x39, 0, 19, 0xB4, 0x03, 0x8D, 0x03, 0xB5, 0x03, 0xE1, 0x04, 0x0C, 0x04, 0x33, 0x04, 0x7D, 0x04, 0xBF, 0x04, 0xFD, 0x05, 0x37,
	0x39, 0, 15, 0xB5, 0x05, 0x9E, 0x05, 0xFB, 0x06, 0x50, 0x06, 0x79, 0x06, 0x8C, 0x06, 0xA0, 0x06, 0xA0,
	0x39, 0, 19, 0xB6, 0x00, 0x00, 0x03, 0x0C, 0x03, 0x1D, 0x03, 0x2E, 0x03, 0x3F, 0x03, 0x61, 0x03, 0x7E, 0x03, 0x9F, 0x03, 0xBE,
	0x39, 0, 19, 0xB7, 0x04, 0x05, 0x04, 0x44, 0x04, 0x85, 0x04, 0xC5, 0x04, 0xFA, 0x05, 0x62, 0x05, 0xBC, 0x06, 0x0F, 0x06, 0x5C,
	0x39, 0, 15, 0xB8, 0x06, 0xE0, 0x07, 0x57, 0x07, 0xC1, 0x07, 0xF4, 0x08, 0x0C, 0x08, 0x26, 0x08, 0x26,
	0x39, 0, 2, 0xBF, 0x11,
	0x39, 0, 19, 0xB0, 0x00, 0x00, 0x03, 0x7E, 0x03, 0x86, 0x03, 0x8E, 0x03, 0x96, 0x03, 0xA7, 0x03, 0xB8, 0x03, 0xC9, 0x03, 0xDC,
	0x39, 0, 19, 0xB1, 0x03, 0xFE, 0x04, 0x24, 0x04, 0x4A, 0x04, 0x6F, 0x04, 0x96, 0x04, 0xE2, 0x05, 0x24, 0x05, 0x64, 0x05, 0xA2,
	0x39, 0, 15, 0xB2, 0x06, 0x12, 0x06, 0x78, 0x06, 0xD4, 0x07, 0x01, 0x07, 0x17, 0x07, 0x2B, 0x07, 0x2B,
	0x39, 0, 19, 0xB3, 0x00, 0x00, 0x03, 0x29, 0x03, 0x35, 0x03, 0x41, 0x03, 0x4D, 0x03, 0x65, 0x03, 0x7D, 0x03, 0x8C, 0x03, 0x9B,
	0x39, 0, 19, 0xB4, 0x03, 0xB7, 0x03, 0xD3, 0x03, 0xF2, 0x04, 0x14, 0x04, 0x34, 0x04, 0x72, 0x04, 0xA8, 0x04, 0xDD, 0x05, 0x10,
	0x39, 0, 15, 0xB5, 0x05, 0x6D, 0x05, 0xC0, 0x06, 0x0D, 0x06, 0x32, 0x06, 0x44, 0x06, 0x55, 0x06, 0x55,
	0x39, 0, 19, 0xB6, 0x00, 0x00, 0x03, 0x45, 0x03, 0x54, 0x03, 0x63, 0x03, 0x72, 0x03, 0x91, 0x03, 0xB0, 0x03, 0xCA, 0x03, 0xE3,
	0x39, 0, 19, 0xB7, 0x04, 0x13, 0x04, 0x45, 0x04, 0x78, 0x04, 0xAA, 0x04, 0xDA, 0x05, 0x37, 0x05, 0x85, 0x05, 0xD1, 0x06, 0x16,
	0x39, 0, 15, 0xB8, 0x06, 0x91, 0x07, 0x01, 0x07, 0x64, 0x07, 0x94, 0x07, 0xAB, 0x07, 0xC1, 0x07, 0xC1,
	0x39, 0, 2, 0xBF, 0x10,
	0x39, 0, 19, 0xB0, 0x00, 0x00, 0x03, 0xE6, 0x03, 0xE9, 0x03, 0xEC, 0x03, 0xEF, 0x03, 0xF6, 0x03, 0xFD, 0x04, 0x04, 0x04, 0x0B,
	0x39, 0, 19, 0xB1, 0x04, 0x1A, 0x04, 0x2D, 0x04, 0x45, 0x04, 0x59, 0x04, 0x6E, 0x04, 0x9E, 0x04, 0xCC, 0x04, 0xF8, 0x05, 0x22,
	0x39, 0, 15, 0xB2, 0x05, 0x78, 0x05, 0xC5, 0x06, 0x11, 0x06, 0x36, 0x06, 0x47, 0x06, 0x56, 0x06, 0x56,
	0x39, 0, 19, 0xB3, 0x00, 0x00, 0x03, 0x8D, 0x03, 0x93, 0x03, 0x99, 0x03, 0x9F, 0x03, 0xAC, 0x03, 0xB9, 0x03, 0xC6, 0x03, 0xD3,
	0x39, 0, 19, 0xB4, 0x03, 0xE4, 0x03, 0xF5, 0x04, 0x06, 0x04, 0x17, 0x04, 0x28, 0x04, 0x4E, 0x04, 0x72, 0x04, 0x96, 0x04, 0xB9,
	0x39, 0, 15, 0xB5, 0x04, 0xFC, 0x05, 0x3A, 0x05, 0x77, 0x05, 0x94, 0x05, 0xA1, 0x05, 0xAF, 0x05, 0xAF,
	0x39, 0, 19, 0xB6, 0x00, 0x00, 0x03, 0xB3, 0x03, 0xBA, 0x03, 0xC1, 0x03, 0xC8, 0x03, 0xD7, 0x03, 0xE6, 0x03, 0xF5, 0x04, 0x04,
	0x39, 0, 19, 0xB7, 0x04, 0x1D, 0x04, 0x37, 0x04, 0x56, 0x04, 0x74, 0x04, 0x92, 0x04, 0xD1, 0x05, 0x0B, 0x05, 0x43, 0x05, 0x79,
	0x39, 0, 15, 0xB8, 0x05, 0xDD, 0x06, 0x35, 0x06, 0x8B, 0x06, 0xB3, 0x06, 0xC5, 0x06, 0xD9, 0x06, 0xD9,
	0x39, 0, 6, 0xF0, 0x55, 0xAA, 0x52, 0x08, 0x02,
	0x39, 0, 2, 0xBF, 0x42,
	0x39, 0, 19, 0xB0, 0x00, 0x00, 0x03, 0xB0, 0x03, 0xDA, 0x04, 0x04, 0x04, 0x2E, 0x04, 0x77, 0x04, 0xB8, 0x04, 0xF8, 0x05, 0x33,
	0x39, 0, 19, 0xB1, 0x05, 0xA6, 0x06, 0x06, 0x06, 0x64, 0x06, 0xB6, 0x06, 0xFF, 0x07, 0x8D, 0x08, 0x03, 0x08, 0x69, 0x08, 0xCD,
	0x39, 0, 15, 0xB2, 0x09, 0x7A, 0x0A, 0x10, 0x0A, 0x94, 0x0A, 0xCF, 0x0A, 0xEE, 0x0B, 0x0C, 0x0B, 0x0C,
	0x39, 0, 19, 0xB3, 0x00, 0x00, 0x03, 0x06, 0x03, 0x2A, 0x03, 0x4E, 0x03, 0x65, 0x03, 0x97, 0x03, 0xDB, 0x04, 0x1E, 0x04, 0x5A,
	0x39, 0, 19, 0xB4, 0x04, 0xCF, 0x05, 0x25, 0x05, 0x79, 0x05, 0xC3, 0x06, 0x03, 0x06, 0x80, 0x06, 0xE1, 0x07, 0x3B, 0x07, 0x93,
	0x39, 0, 15, 0xB5, 0x08, 0x27, 0x08, 0xA5, 0x09, 0x1A, 0x09, 0x4C, 0x09, 0x67, 0x09, 0x80, 0x09, 0x80,
	0x39, 0, 19, 0xB6, 0x00, 0x00, 0x03, 0x3D, 0x03, 0x76, 0x03, 0xAF, 0x03, 0xDF, 0x04, 0x41, 0x04, 0xA4, 0x05, 0x06, 0x05, 0x55,
	0x39, 0, 19, 0xB7, 0x05, 0xF1, 0x06, 0x63, 0x06, 0xD4, 0x07, 0x2D, 0x07, 0x7D, 0x08, 0x1B, 0x08, 0x95, 0x09, 0x00, 0x09, 0x6A,
	0x39, 0, 15, 0xB8, 0x0A, 0x1E, 0x0A, 0xBE, 0x0B, 0x51, 0x0B, 0x93, 0x0B, 0xB7, 0x0B, 0xD9, 0x0B, 0xD9,
	0x39, 0, 2, 0xBF, 0x41,
	0x39, 0, 19, 0xB0, 0x00, 0x00, 0x02, 0xCF, 0x03, 0xCB, 0x03, 0xEB, 0x04, 0x0B, 0x04, 0x47, 0x04, 0x7E, 0x04, 0xCC, 0x04, 0xFD,
	0x39, 0, 19, 0xB1, 0x05, 0x2A, 0x05, 0x78, 0x05, 0xC9, 0x06, 0x12, 0x06, 0x99, 0x06, 0xE1, 0x07, 0x30, 0x07, 0x9A, 0x07, 0xF4,
	0x39, 0, 15, 0xB2, 0x08, 0x44, 0x08, 0xE8, 0x09, 0xAD, 0x09, 0xE6, 0x0A, 0x03, 0x0A, 0x1D, 0x0A, 0x20,
	0x39, 0, 19, 0xB3, 0x00, 0x00, 0x02, 0x4E, 0x03, 0x1D, 0x03, 0x39, 0x03, 0x52, 0x03, 0x76, 0x03, 0x9E, 0x03, 0xF0, 0x04, 0x23,
	0x39, 0, 19, 0xB4, 0x04, 0x50, 0x04, 0xA0, 0x04, 0xEE, 0x05, 0x2F, 0x05, 0xA9, 0x05, 0xE9, 0x06, 0x2E, 0x06, 0x8B, 0x06, 0xD5,
	0x39, 0, 15, 0xB5, 0x07, 0x1A, 0x07, 0xAA, 0x08, 0x52, 0x08, 0x82, 0x08, 0x9A, 0x08, 0xB1, 0x08, 0xB3,
	0x39, 0, 19, 0xB6, 0x00, 0x00, 0x02, 0x78, 0x03, 0x62, 0x03, 0x8D, 0x03, 0xB7, 0x04, 0x01, 0x04, 0x4C, 0x04, 0xC3, 0x05, 0x0C,
	0x39, 0, 19, 0xB7, 0x05, 0x48, 0x05, 0xB3, 0x06, 0x1A, 0x06, 0x71, 0x07, 0x0E, 0x07, 0x5C, 0x07, 0xB4, 0x08, 0x28, 0x08, 0x85,
	0x39, 0, 15, 0xB8, 0x08, 0xD9, 0x09, 0x86, 0x0A, 0x54, 0x0A, 0x91, 0x0A, 0xB0, 0x0A, 0xCD, 0x0A, 0xD0,
	0x39, 0, 2, 0xBF, 0x40,
	0x39, 0, 19, 0xB0, 0x00, 0x00, 0x03, 0xCD, 0x03, 0xD2, 0x03, 0xD7, 0x03, 0xDC, 0x03, 0xF4, 0x04, 0x10, 0x04, 0x2A, 0x04, 0x42,
	0x39, 0, 19, 0xB1, 0x04, 0x6F, 0x04, 0x99, 0x04, 0xC1, 0x04, 0xF0, 0x05, 0x17, 0x05, 0x62, 0x05, 0xAB, 0x05, 0xED, 0x06, 0x2E,
	0x39, 0, 15, 0xB2, 0x06, 0x9C, 0x06, 0xFE, 0x07, 0x5C, 0x07, 0x8C, 0x07, 0xA0, 0x07, 0xB2, 0x07, 0xB2,
	0x39, 0, 19, 0xB3, 0x00, 0x00, 0x03, 0x2F, 0x03, 0x37, 0x03, 0x3F, 0x03, 0x44, 0x03, 0x4B, 0x03, 0x54, 0x03, 0x5B, 0x03, 0x6D,
	0x39, 0, 19, 0xB4, 0x03, 0x8F, 0x03, 0xB8, 0x03, 0xE0, 0x04, 0x0E, 0x04, 0x38, 0x04, 0x8A, 0x04, 0xCF, 0x05, 0x0D, 0x05, 0x49,
	0x39, 0, 15, 0xB5, 0x05, 0xAF, 0x06, 0x06, 0x06, 0x56, 0x06, 0x79, 0x06, 0x8C, 0x06, 0x9E, 0x06, 0x9E,
	0x39, 0, 19, 0xB6, 0x00, 0x00, 0x03, 0x72, 0x03, 0x78, 0x03, 0x7E, 0x03, 0x83, 0x03, 0x9B, 0x03, 0xB6, 0x03, 0xCF, 0x03, 0xF0,
	0x39, 0, 19, 0xB7, 0x04, 0x30, 0x04, 0x70, 0x04, 0xAE, 0x04, 0xF1, 0x05, 0x27, 0x05, 0x91, 0x05, 0xEF, 0x06, 0x3F, 0x06, 0x8D,
	0x39, 0, 15, 0xB8, 0x07, 0x11, 0x07, 0x80, 0x07, 0xE1, 0x08, 0x11, 0x08, 0x28, 0x08, 0x3D, 0x08, 0x3D,
	0x39, 0, 2, 0xCE, 0x01,
	0x39, 0, 2, 0xCC, 0x00,
	0x39, 0, 6, 0xF0, 0x55, 0xAA, 0x52, 0x08, 0x02,
	0x39, 0, 25, 0xB9, 0x00, 0x04, 0x00, 0x0C, 0x00, 0x14, 0x00, 0x1C, 0x00, 0x2C, 0x00, 0x3C, 0x00, 0x5C, 0x00, 0x7C, 0x00, 0x9C, 0x00, 0xBC, 0x00, 0xDC, 0x00, 0xFC,
	0x39, 0, 25, 0xBA, 0x01, 0x3C, 0x01, 0x7C, 0x01, 0xBC, 0x01, 0xFC, 0x02, 0x3C, 0x02, 0x7C, 0x02, 0xFC, 0x03, 0x7C, 0x03, 0xBC, 0x03, 0xDC, 0x03, 0xFC, 0x03, 0xFF,

	/////////#1_gamma.txt end///////////
#endif


	0x39, 0, 6, 0xF0, 0x55, 0xAA, 0x52, 0x08, 0x03,
	0x39, 0, 6, 0xB2, 0x00, 0x1F, 0x1F, 0x06, 0x01,
	0x39, 0, 2, 0x6F, 0x05,
	0x39, 0, 13, 0xB2, 0x00, 0x10, 0x10, 0x00, 0x0F, 0x0F, 0x00, 0x10, 0x10, 0x00, 0x1F, 0x1F,
	0x39, 0, 2, 0x6F, 0x11,
	0x39, 0, 9, 0xB2, 0x06, 0x01, 0x06, 0x01, 0x06, 0x01, 0x06, 0x01,
	0x39, 0, 2, 0x6F, 0x19,
	0x39, 0, 2, 0xB2, 0x00,
	0x39, 0, 16, 0xB6, 0xF0, 0x1C, 0x1C, 0x00, 0x10, 0x01, 0x00, 0x10, 0x01, 0x00, 0x10, 0x01, 0x00, 0x1C, 0x1C,
	0x39, 0, 2, 0x6F, 0x0F,
	0x39, 0, 4, 0xB6, 0x1F, 0x00, 0x0A,
	0x39, 0, 2, 0x6F, 0x1A,
	0x39, 0, 4, 0xB6, 0x0F, 0x00, 0x0A,
	0x39, 0, 2, 0x6F, 0x25,
	0x39, 0, 4, 0xB6, 0x0F, 0x00, 0x0A,
	0x39, 0, 2, 0x6F, 0x30,
	0x39, 0, 4, 0xB6, 0x0F, 0x00, 0x0A,
	0x39, 0, 17, 0xBB, 0x11, 0x00, 0x1D, 0x7E, 0x00, 0x0F, 0x5E, 0x00, 0x0E, 0x4C, 0x00, 0x00, 0x00, 0x00, 0x1D, 0x7E,
	0x39, 0, 17, 0xBC, 0x22, 0x10, 0x1D, 0x5C, 0x00, 0x0F, 0x3C, 0x00, 0x0E, 0x29, 0x00, 0x00, 0x00, 0x00, 0x1D, 0x5C,
	0x39, 0, 6, 0xF0, 0x55, 0xAA, 0x52, 0x08, 0x04,
	0x39, 0, 2, 0xC2, 0x14,
	0x39, 0, 2, 0xB1, 0x02,
	0x39, 0, 2, 0xB2, 0x40,
	0x39, 0, 2, 0x6F, 0x01,
	0x39, 0, 4, 0xB2, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x04,
	0x39, 0, 4, 0xB2, 0x09, 0xE3, 0x40,
	0x39, 0, 2, 0x6F, 0x07,
	0x39, 0, 4, 0xB2, 0x09, 0xE4, 0x00,
	0x39, 0, 2, 0x6F, 0x0A,
	0x39, 0, 4, 0xB2, 0x09, 0xE3, 0x40,
	0x39, 0, 2, 0xCB, 0x86,
	0x39, 0, 5, 0xD0, 0x00, 0x00, 0x00, 0x10,
	0x39, 0, 2, 0x6F, 0x04,
	0x39, 0, 2, 0xD0, 0x01,
	0x39, 0, 2, 0x6F, 0x01,
	0x39, 0, 6, 0xCB, 0x05, 0x0F, 0x1F, 0x3E, 0x7C,
	0x39, 0, 2, 0x6F, 0x06,
	0x39, 0, 11, 0xCB, 0x00, 0x08, 0x00, 0x3C, 0x01, 0x48, 0x07, 0xFF, 0x0F, 0xFF,
	0x39, 0, 2, 0x6F, 0x00,
	0x39, 0, 6, 0xD2, 0x12, 0x0C, 0x0C, 0x0A, 0x06,
	0x39, 0, 2, 0x6F, 0x05,
	0x39, 0, 6, 0xD2, 0x30, 0x14, 0x16, 0x0E, 0x0A,
	0x39, 0, 2, 0x6F, 0x0A,
	0x39, 0, 6, 0xD2, 0x48, 0x20, 0x16, 0x12, 0x0E,
	0x39, 0, 2, 0x6F, 0x0F,
	0x39, 0, 6, 0xD2, 0x44, 0x20, 0x16, 0x12, 0x15,
	0x39, 0, 2, 0x6F, 0x14,
	0x39, 0, 6, 0xD2, 0x40, 0x20, 0x16, 0x12, 0x12,
	0x39, 0, 2, 0x6F, 0x19,
	0x39, 0, 6, 0xD2, 0xFF, 0xE4, 0xA9, 0x40, 0x30,
	0x39, 0, 2, 0x6F, 0x1E,
	0x39, 0, 6, 0xD2, 0xFF, 0xD8, 0x40, 0x26, 0x20,
	0x39, 0, 2, 0x6F, 0x23,
	0x39, 0, 6, 0xD2, 0xFF, 0x8F, 0x40, 0x26, 0x1F,
	0x39, 0, 2, 0x6F, 0x28,
	0x39, 0, 6, 0xD2, 0x9F, 0x60, 0x40, 0x20, 0x1B,
	0x39, 0, 2, 0x6F, 0x2D,
	0x39, 0, 6, 0xD2, 0x84, 0x40, 0x40, 0x20, 0x1B,
	0x39, 0, 2, 0x6F, 0x32,
	0x39, 0, 6, 0xD2, 0x12, 0x08, 0x10, 0x10, 0x06,
	0x39, 0, 2, 0x6F, 0x37,
	0x39, 0, 6, 0xD2, 0x30, 0x08, 0x15, 0x0B, 0x0A,
	0x39, 0, 2, 0x6F, 0x3C,
	0x39, 0, 6, 0xD2, 0x46, 0x08, 0x10, 0x10, 0x0C,
	0x39, 0, 2, 0x6F, 0x41,
	0x39, 0, 6, 0xD2, 0x30, 0x1A, 0x10, 0x16, 0x16,
	0x39, 0, 2, 0x6F, 0x46,
	0x39, 0, 6, 0xD2, 0x30, 0x1A, 0x10, 0x12, 0x12,
	0x39, 0, 2, 0x6F, 0x00,
	0x39, 0, 6, 0xD4, 0x08, 0x08, 0x04, 0x0C, 0x06,
	0x39, 0, 2, 0x6F, 0x05,
	0x39, 0, 6, 0xD4, 0x29, 0x18, 0x10, 0x0D, 0x0A,
	0x39, 0, 2, 0x6F, 0x0A,
	0x39, 0, 6, 0xD4, 0x40, 0x14, 0x10, 0x11, 0x0C,
	0x39, 0, 2, 0x6F, 0x0F,
	0x39, 0, 6, 0xD4, 0x40, 0x1F, 0x13, 0x14, 0x10,
	0x39, 0, 2, 0x6F, 0x14,
	0x39, 0, 6, 0xD4, 0x5f, 0x16, 0x14, 0x16, 0x13,
	0x39, 0, 2, 0x6F, 0x19,
	0x39, 0, 6, 0xD4, 0xFF, 0xFF, 0xA0, 0x50, 0x2F,
	0x39, 0, 2, 0x6F, 0x1E,
	0x39, 0, 6, 0xD4, 0xFF, 0xF0, 0x9A, 0x30, 0x0C,
	0x39, 0, 2, 0x6F, 0x23,
	0x39, 0, 6, 0xD4, 0xFF, 0xA0, 0x6A, 0x30, 0x0F,
	0x39, 0, 2, 0x6F, 0x28,
	0x39, 0, 6, 0xD4, 0xF0, 0x80, 0x40, 0x30, 0x12,
	0x39, 0, 2, 0x6F, 0x2D,
	0x39, 0, 6, 0xD4, 0xB0, 0x40, 0x40, 0x30, 0x14,
	0x39, 0, 2, 0x6F, 0x32,
	0x39, 0, 6, 0xD4, 0x04, 0x04, 0x04, 0x0A, 0x05,
	0x39, 0, 2, 0x6F, 0x37,
	0x39, 0, 6, 0xD4, 0x32, 0x14, 0x10, 0x0B, 0x07,
	0x39, 0, 2, 0x6F, 0x3C,
	0x39, 0, 6, 0xD4, 0x40, 0x18, 0x10, 0x0C, 0x09,
	0x39, 0, 2, 0x6F, 0x41,
	0x39, 0, 6, 0xD4, 0x20, 0x1C, 0x1A, 0x0E, 0x0B,
	0x39, 0, 2, 0x6F, 0x46,
	0x39, 0, 6, 0xD4, 0xB5, 0x18, 0x18, 0x08, 0x0C,
	0x39, 0, 6, 0xF0, 0x55, 0xAA, 0x52, 0x08, 0x05,
	0x39, 0, 3, 0xC7, 0x07, 0x01,
	0x39, 0, 4, 0xB0, 0x07, 0x21, 0x00,
	0x39, 0, 3, 0xB3, 0x86, 0x80,
	0x39, 0, 3, 0xB5, 0x85, 0x81,
	0x39, 0, 5, 0xB7, 0x85, 0x00, 0x00, 0x81,
	0x39, 0, 5, 0xB8, 0x85, 0x00, 0x00, 0x81,
	0x39, 0, 5, 0xB9, 0x85, 0x00, 0x00, 0x81,
	0x39, 0, 4, 0xD0, 0x00, 0x03, 0x10,
	0x39, 0, 5, 0xE0, 0x82, 0x00, 0x00, 0x02,
	0x39, 0, 4, 0xD1, 0x00, 0x01, 0x10,
	0x39, 0, 5, 0xE1, 0x82, 0x00, 0x00, 0x02,
	0x39, 0, 6, 0xF0, 0x55, 0xAA, 0x52, 0x08, 0x06,
	0x39, 0, 6, 0xB0, 0x13, 0x32, 0x12, 0x32, 0x04,
	0x39, 0, 6, 0xB1, 0x32, 0x31, 0x0E, 0x32, 0x31,
	0x39, 0, 6, 0xB2, 0x32, 0x00, 0x32, 0x31, 0x32,
	0x39, 0, 2, 0xB3, 0x0F,
	0x39, 0, 6, 0xB6, 0x13, 0x32, 0x12, 0x32, 0x04,
	0x39, 0, 6, 0xB7, 0x32, 0x31, 0x0E, 0x32, 0x31,
	0x39, 0, 6, 0xB8, 0x32, 0x00, 0x32, 0x31, 0x32,
	0x39, 0, 2, 0xB9, 0x0F,
	0x39, 0, 2, 0xD0, 0x01,
	0x39, 0, 6, 0xF0, 0x55, 0xAA, 0x52, 0x08, 0x07,
	0x39, 0, 2, 0xB4, 0xC0,
	0x39, 0, 6, 0xB0, 0x84, 0xC0, 0x78, 0x70, 0x00,
	0x39, 0, 7, 0xB1, 0x0C, 0x1C, 0x00, 0x1C, 0x0C, 0x00,
	0x39, 0, 2, 0xB2, 0x20,
	0x39, 0, 2, 0x6F, 0x36,
	0x39, 0, 2, 0xB2, 0x32,
	0x39, 0, 2, 0x6F, 0x3F,
	0x39, 0, 2, 0xB2, 0x04,
	0x39, 0, 2, 0x6F, 0x09,
	0x39, 0, 2, 0xB2, 0x20,
	0x39, 0, 2, 0x6F, 0x48,
	0x39, 0, 2, 0xB2, 0x32,
	0x39, 0, 2, 0x6F, 0x51,
	0x39, 0, 2, 0xB2, 0x04,
	0x39, 0, 2, 0x6F, 0x12,
	0x39, 0, 2, 0xB2, 0xF0,
	0x39, 0, 2, 0x6F, 0x5A,
	0x39, 0, 2, 0xB2, 0x03,
	0x39, 0, 2, 0x6F, 0x63,
	0x39, 0, 2, 0xB2, 0x9B,
	0x39, 0, 2, 0x6F, 0x1B,
	0x39, 0, 2, 0xB2, 0x20,
	0x39, 0, 2, 0x6F, 0x6C,
	0x39, 0, 2, 0xB2, 0x32,
	0x39, 0, 2, 0x6F, 0x75,
	0x39, 0, 2, 0xB2, 0x04,
	0x39, 0, 2, 0x6F, 0x24,
	0x39, 0, 2, 0xB2, 0x20,
	0x39, 0, 2, 0x6F, 0x7E,
	0x39, 0, 2, 0xB2, 0x32,
	0x39, 0, 2, 0x6F, 0x87,
	0x39, 0, 2, 0xB2, 0x04,
	0x39, 0, 2, 0x6F, 0x2D,
	0x39, 0, 2, 0xB2, 0xCC,
	0x39, 0, 2, 0x6F, 0x90,
	0x39, 0, 2, 0xB2, 0x03,
	0x39, 0, 2, 0x6F, 0x99,
	0x39, 0, 2, 0xB2, 0x3A,
	0x39, 0, 2, 0xB4, 0xC0,
	0x39, 0, 3, 0xB7, 0x00, 0x00,
	0x39, 0, 6, 0xC0, 0x01, 0x01, 0x00, 0x00, 0x55,
	0x39, 0, 2, 0x6F, 0x00,
	0x39, 0, 22, 0xC1, 0x2C, 0x00, 0x1C, 0x39, 0x1C, 0x39, 0x38, 0x72, 0x3F, 0xD9, 0xA2, 0x84, 0x40, 0x00, 0xE7, 0x18, 0x80, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x15,
	0x39, 0, 16, 0xC1, 0x90, 0x00, 0x0A, 0x90, 0x59, 0x5F, 0x33, 0xE0, 0x00, 0x00, 0x0C, 0xAB, 0x59, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x24,
	0x39, 0, 8, 0xC1, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x00,
	0x39, 0, 22, 0xC2, 0x2A, 0x0F, 0x1C, 0x39, 0x1C, 0x39, 0xC7, 0x8E, 0x00, 0x12, 0xBD, 0xDA, 0x40, 0x14, 0x86, 0xBA, 0xFF, 0xF6, 0x12, 0xBF, 0x8D,
	0x39, 0, 2, 0x6F, 0x15,
	0x39, 0, 16, 0xC2, 0x93, 0xDE, 0x0A, 0x94, 0x37, 0x5F, 0x33, 0xEF, 0xE2, 0x73, 0x00, 0x55, 0x59, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x24,
	0x39, 0, 8, 0xC2, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x00,
	0x39, 0, 22, 0xC3, 0x26, 0x00, 0x1C, 0x39, 0x1C, 0x39, 0x38, 0x72, 0x00, 0x00, 0x00, 0x00, 0x3F, 0xD8, 0xBB, 0x6C, 0x80, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x15,
	0x39, 0, 16, 0xC3, 0x03, 0xDE, 0x00, 0x04, 0x37, 0x55, 0x33, 0x60, 0x00, 0x00, 0x03, 0x55, 0xA7, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x24,
	0x39, 0, 8, 0xC3, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x00,
	0x39, 0, 22, 0xC4, 0x20, 0x0F, 0x1C, 0x39, 0x1C, 0x39, 0xC7, 0x8E, 0x3F, 0xEC, 0x60, 0x5E, 0x3F, 0xEC, 0x5B, 0x0E, 0x80, 0x03, 0x69, 0x3F, 0xA9,
	0x39, 0, 2, 0x6F, 0x15,
	0x39, 0, 16, 0xC4, 0x00, 0x00, 0x00, 0x00, 0x59, 0x55, 0x33, 0x60, 0x1D, 0x8D, 0x0F, 0xAB, 0xA7, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x24,
	0x39, 0, 8, 0xC4, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x00,
	0x39, 0, 22, 0xC5, 0x21, 0x00, 0x03, 0xC1, 0x03, 0x49, 0x00, 0x00, 0x3F, 0xFF, 0x26, 0x46, 0x3F, 0xFF, 0x34, 0x52, 0x00, 0x00, 0x0C, 0x55, 0x09,
	0x39, 0, 2, 0x6F, 0x15,
	0x39, 0, 16, 0xC5, 0x01, 0xFE, 0x14, 0x02, 0x1B, 0x33, 0x33, 0x80, 0x03, 0x83, 0x0F, 0xE1, 0xE3, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x24,
	0x39, 0, 8, 0xC5, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x00,
	0x39, 0, 22, 0xC6, 0x27, 0x00, 0x03, 0x84, 0x03, 0x49, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3F, 0xFF, 0x3A, 0xE4, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x15,
	0x39, 0, 16, 0xC6, 0x02, 0x1C, 0x14, 0x02, 0x39, 0x32, 0x33, 0x80, 0x00, 0x00, 0x03, 0x1E, 0xE3, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x24,
	0x39, 0, 8, 0xC6, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x00,
	0x39, 0, 22, 0xC7, 0x2D, 0x00, 0x03, 0x84, 0x03, 0x49, 0x00, 0x00, 0x3F, 0xFF, 0x34, 0x18, 0x00, 0x00, 0x00, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x15,
	0x39, 0, 16, 0xC7, 0x01, 0xFE, 0x34, 0x02, 0x1B, 0x52, 0x33, 0x50, 0x00, 0x00, 0x0C, 0xE2, 0x1D, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x24,
	0x39, 0, 8, 0xC7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x00,
	0x39, 0, 22, 0xC8, 0x2B, 0x00, 0x03, 0xC1, 0x03, 0x49, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0xF3, 0xAA, 0xF7,
	0x39, 0, 2, 0x6F, 0x15,
	0x39, 0, 16, 0xC8, 0x02, 0x1C, 0x33, 0x02, 0x39, 0x52, 0x33, 0x6F, 0xFC, 0x7D, 0x00, 0x1F, 0x1D, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x24,
	0x39, 0, 8, 0xC8, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x00,
	0x39, 0, 22, 0xC9, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x15,
	0x39, 0, 16, 0xC9, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x24,
	0x39, 0, 8, 0xC9, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x00,
	0x39, 0, 22, 0xCA, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x15,
	0x39, 0, 16, 0xCA, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x24,
	0x39, 0, 8, 0xCA, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x00,
	0x39, 0, 22, 0xCB, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x15,
	0x39, 0, 16, 0xCB, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x24,
	0x39, 0, 8, 0xCB, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x00,
	0x39, 0, 22, 0xCC, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x15,
	0x39, 0, 16, 0xCC, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x24,
	0x39, 0, 8, 0xCC, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x00,
	0x39, 0, 22, 0xCD, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x15,
	0x39, 0, 16, 0xCD, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x24,
	0x39, 0, 8, 0xCD, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x00,
	0x39, 0, 22, 0xCE, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x15,
	0x39, 0, 16, 0xCE, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x24,
	0x39, 0, 8, 0xCE, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x00,
	0x39, 0, 22, 0xCF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x15,
	0x39, 0, 16, 0xCF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x24,
	0x39, 0, 8, 0xCF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x00,
	0x39, 0, 22, 0xD0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x15,
	0x39, 0, 16, 0xD0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x24,
	0x39, 0, 8, 0xD0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x00,
	0x39, 0, 22, 0xD1, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x15,
	0x39, 0, 16, 0xD1, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x24,
	0x39, 0, 8, 0xD1, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x00,
	0x39, 0, 22, 0xD2, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x15,
	0x39, 0, 16, 0xD2, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x24,
	0x39, 0, 8, 0xD2, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x00,
	0x39, 0, 22, 0xD3, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x15,
	0x39, 0, 16, 0xD3, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x24,
	0x39, 0, 8, 0xD3, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x00,
	0x39, 0, 22, 0xD4, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x15,
	0x39, 0, 16, 0xD4, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x24,
	0x39, 0, 8, 0xD4, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x00,
	0x39, 0, 22, 0xD5, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x15,
	0x39, 0, 16, 0xD5, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x24,
	0x39, 0, 8, 0xD5, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x00,
	0x39, 0, 22, 0xD6, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x15,
	0x39, 0, 16, 0xD6, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x24,
	0x39, 0, 8, 0xD6, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x00,
	0x39, 0, 22, 0xD7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x15,
	0x39, 0, 16, 0xD7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x24,
	0x39, 0, 8, 0xD7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x00,
	0x39, 0, 22, 0xD8, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x15,
	0x39, 0, 16, 0xD8, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x24,
	0x39, 0, 8, 0xD8, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 6, 0xF0, 0x55, 0xAA, 0x52, 0x08, 0x08,
	0x39, 0, 17, 0xB6, 0x0F, 0xFE, 0x0F, 0xFE, 0x0F, 0xFE, 0x0F, 0xFE, 0x0F, 0xFE, 0x0F, 0xFE, 0x0F, 0xFE, 0x0F, 0xFE,
	0x39, 0, 2, 0x6F, 0x10,
	0x39, 0, 17, 0xB6, 0x0F, 0xFE, 0x0F, 0xFE, 0x0F, 0xFE, 0x0F, 0xFE, 0x0F, 0xFE, 0x0F, 0xFE, 0x0F, 0xFE, 0x0F, 0xFE,
	0x39, 0, 2, 0x6F, 0x20,
	0x39, 0, 7, 0xB6, 0x0F, 0xFE, 0x0F, 0xFE, 0x0F, 0xFE,
	0x39, 0, 17, 0xB7, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00,
	0x39, 0, 2, 0x6F, 0x10,
	0x39, 0, 17, 0xB7, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00,
	0x39, 0, 2, 0x6F, 0x20,
	0x39, 0, 7, 0xB7, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00,
	0x39, 0, 17, 0xB8, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00,
	0x39, 0, 2, 0x6F, 0x10,
	0x39, 0, 17, 0xB8, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00,
	0x39, 0, 2, 0x6F, 0x20,
	0x39, 0, 7, 0xB8, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00,
	0x39, 0, 17, 0xB9, 0x01, 0x01, 0x00, 0x91, 0x00, 0x38, 0x60, 0x00, 0x00, 0x00, 0xA6, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x10,
	0x39, 0, 17, 0xB9, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x05, 0x00, 0x0C, 0x00, 0x1F, 0x00, 0x44, 0x00, 0x86, 0x00,
	0x39, 0, 2, 0x6F, 0x20,
	0x39, 0, 17, 0xB9, 0xF5, 0x01, 0xB3, 0x02, 0xD7, 0x04, 0x1C, 0x05, 0x61, 0x06, 0xA6, 0x07, 0xEB, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x30,
	0x39, 0, 17, 0xB9, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x02, 0x00, 0x05, 0x00, 0x0C, 0x00, 0x18, 0x00, 0x2C, 0x00,
	0x39, 0, 2, 0x6F, 0x40,
	0x39, 0, 17, 0xB9, 0x4F, 0x00, 0xAD, 0x01, 0x27, 0x01, 0xA1, 0x02, 0x1B, 0x02, 0x95, 0x03, 0x0F, 0x03, 0x89, 0x00,
	0x39, 0, 2, 0x6F, 0x50,
	0x39, 0, 17, 0xB9, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x0D, 0x00, 0x1D, 0x00,
	0x39, 0, 2, 0x6F, 0x60,
	0x39, 0, 17, 0xB9, 0x48, 0x00, 0x9D, 0x01, 0x34, 0x02, 0x32, 0x03, 0xE4, 0x05, 0xF6, 0x08, 0xF1, 0x0B, 0xEC, 0x0E,
	0x39, 0, 2, 0x6F, 0x70,
	0x39, 0, 17, 0xB9, 0xE7, 0x03, 0xD0, 0xB0, 0xE0, 0x0A, 0x80, 0x80, 0x82, 0x7D, 0x7B, 0x79, 0x77, 0x72, 0x70, 0x80,
	0x39, 0, 2, 0x6F, 0x80,
	0x39, 0, 17, 0xB9, 0x80, 0x80, 0x7D, 0x7E, 0x7B, 0x7B, 0x77, 0x73, 0x80, 0x80, 0x82, 0x81, 0x80, 0x7F, 0x7E, 0x7B,
	0x39, 0, 2, 0x6F, 0x90,
	0x39, 0, 17, 0xB9, 0x78, 0x80, 0x80, 0x81, 0x82, 0x82, 0x82, 0x81, 0x7F, 0x7C, 0x80, 0x80, 0x80, 0x83, 0x86, 0x86,
	0x39, 0, 2, 0x6F, 0xA0,
	0x39, 0, 17, 0xB9, 0x85, 0x81, 0x7D, 0x80, 0x80, 0x82, 0x81, 0x84, 0x85, 0x87, 0x85, 0x88, 0x80, 0x80, 0x81, 0x8B,
	0x39, 0, 2, 0x6F, 0xB0,
	0x39, 0, 17, 0xB9, 0x88, 0x8A, 0x8C, 0x8D, 0x8E, 0x80, 0x80, 0x84, 0x87, 0x8A, 0x8C, 0x8F, 0x90, 0x91, 0x80, 0x80,
	0x39, 0, 2, 0x6F, 0xC0,
	0x39, 0, 17, 0xB9, 0x84, 0x87, 0x8A, 0x8D, 0x91, 0x91, 0x92, 0x80, 0x80, 0x85, 0x88, 0x8D, 0x8F, 0x8F, 0x95, 0x96,
	0x39, 0, 2, 0x6F, 0xD0,
	0x39, 0, 17, 0xB9, 0x80, 0x80, 0x7A, 0x73, 0x6E, 0x69, 0x66, 0x60, 0x5D, 0x80, 0x80, 0x80, 0x80, 0x76, 0x74, 0x70,
	0x39, 0, 2, 0x6F, 0xE0,
	0x39, 0, 17, 0xB9, 0x6C, 0x6A, 0x80, 0x80, 0x81, 0x7F, 0x7F, 0x7C, 0x7B, 0x76, 0x73, 0x80, 0x80, 0x83, 0x83, 0x83,
	0x39, 0, 2, 0x6F, 0xF0,
	0x39, 0, 14, 0xB9, 0x82, 0x82, 0x7F, 0x7C, 0x80, 0x80, 0x82, 0x84, 0x85, 0x84, 0x87, 0x83, 0x80,
	0x39, 0, 17, 0xBA, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00,
	0x39, 0, 2, 0x6F, 0x10,
	0x39, 0, 17, 0xBA, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00,
	0x39, 0, 2, 0x6F, 0x20,
	0x39, 0, 17, 0xBA, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00,
	0x39, 0, 2, 0x6F, 0x30,
	0x39, 0, 17, 0xBA, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00,
	0x39, 0, 2, 0x6F, 0x40,
	0x39, 0, 17, 0xBA, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00,
	0x39, 0, 2, 0x6F, 0x50,
	0x39, 0, 17, 0xBA, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00,
	0x39, 0, 2, 0x6F, 0x60,
	0x39, 0, 17, 0xBA, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x05, 0xD1, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00,
	0x39, 0, 2, 0x6F, 0x70,
	0x39, 0, 17, 0xBA, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00,
	0x39, 0, 2, 0x6F, 0x80,
	0x39, 0, 17, 0xBA, 0x08, 0x00, 0x05, 0x3E, 0x07, 0x36, 0x07, 0x36, 0x07, 0x36, 0x07, 0x36, 0x07, 0x36, 0x07, 0x36,
	0x39, 0, 2, 0x6F, 0x90,
	0x39, 0, 17, 0xBA, 0x07, 0x36, 0x07, 0x36, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00, 0x05, 0x3E, 0x07, 0x36,
	0x39, 0, 2, 0x6F, 0xA0,
	0x39, 0, 17, 0xBA, 0x07, 0x36, 0x07, 0x36, 0x07, 0x36, 0x07, 0x36, 0x07, 0x36, 0x07, 0x36, 0x07, 0x36, 0x08, 0x00,
	0x39, 0, 2, 0x6F, 0xB0,
	0x39, 0, 17, 0xBA, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00, 0x05, 0xD1, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00,
	0x39, 0, 2, 0x6F, 0xC0,
	0x39, 0, 17, 0xBA, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00,
	0x39, 0, 2, 0x6F, 0xD0,
	0x39, 0, 17, 0xBA, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00,
	0x39, 0, 2, 0x6F, 0xE0,
	0x39, 0, 11, 0xBA, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00,
	0x39, 0, 17, 0xBB, 0x01, 0x2C, 0x01, 0x2C, 0x01, 0x2C, 0x01, 0x2C, 0x01, 0x2C, 0x01, 0x2C, 0x01, 0x2C, 0x01, 0x2C,
	0x39, 0, 2, 0x6F, 0x10,
	0x39, 0, 17, 0xBB, 0x01, 0x2C, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x2C, 0x01, 0x2C, 0x01, 0x2C,
	0x39, 0, 2, 0x6F, 0x20,
	0x39, 0, 17, 0xBB, 0x01, 0x2C, 0x01, 0x2C, 0x01, 0x2C, 0x01, 0x2C, 0x01, 0x2C, 0x01, 0x2C, 0x01, 0x00, 0x01, 0x00,
	0x39, 0, 2, 0x6F, 0x30,
	0x39, 0, 17, 0xBB, 0x01, 0x00, 0x01, 0x00, 0x01, 0x2C, 0x01, 0x2C, 0x01, 0x2C, 0x01, 0x2C, 0x01, 0x2C, 0x01, 0x2C,
	0x39, 0, 2, 0x6F, 0x40,
	0x39, 0, 17, 0xBB, 0x01, 0x2C, 0x01, 0x2C, 0x01, 0x2C, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x2C,
	0x39, 0, 2, 0x6F, 0x50,
	0x39, 0, 17, 0xBB, 0x01, 0x2C, 0x01, 0x2C, 0x01, 0x2C, 0x01, 0x2C, 0x01, 0x2C, 0x01, 0x2C, 0x01, 0x2C, 0x01, 0x2C,
	0x39, 0, 2, 0x6F, 0x60,
	0x39, 0, 17, 0xBB, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00,
	0x39, 0, 2, 0x6F, 0x70,
	0x39, 0, 17, 0xBB, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00,
	0x39, 0, 2, 0x6F, 0x80,
	0x39, 0, 17, 0xBB, 0x01, 0x00, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x90,
	0x39, 0, 17, 0xBB, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x10, 0x10,
	0x39, 0, 2, 0x6F, 0xA0,
	0x39, 0, 5, 0xBB, 0x80, 0x80, 0x80, 0x00,
	0x39, 0, 2, 0xEE, 0x05,
	0x39, 0, 5, 0xFF, 0xAA, 0x55, 0xA5, 0x80,
	0x39, 0, 2, 0x6F, 0x1D,
	0x39, 0, 2, 0xF2, 0x05,
	0x39, 0, 5, 0x3B, 0x00, 0x14, 0x00, 0x12,
	0x39, 0, 2, 0x03, 0x01,
	0x39, 0, 2, 0x90, 0x02,
	0x39, 0, 19, 0x91, 0x89, 0x28, 0x00, 0x0C, 0xC2, 0x00, 0x03, 0x1C, 0x01, 0x7E, 0x00, 0x0F, 0x08, 0xBB, 0x04, 0x3D, 0x10, 0xF0,
	0x39, 0, 1, 0x2C,
	0x39, 0, 5, 0x51, 0x07, 0xFF, 0x0F, 0xFF,
	0x39, 0, 2, 0x53, 0x20,
	0x39, 0, 1, 0x35,
	0x39, 0, 5, 0x2A, 0x00, 0x00, 0x04, 0x37,
	0x39, 0, 5, 0x2B, 0x00, 0x00, 0x09, 0x5F,
	0x39, 0, 2, 0x2F, 0x01,
#endif

#if FINGERPRINT_USE_DRIVERIC_FPR

#if  0
//v01
	0x39, 0, 6, 0xF0, 0x55, 0xAA, 0x52, 0x08, 0x07,
	0x39, 0, 15, 0xC0, 0x01, 0x01, 0x00, 0x00, 0x55, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,

	0x39, 0, 2, 0x6F, 0x00,
	0x39, 0, 22, 0xC9, 0x21, 0x00, 0x29, 0x71, 0x29, 0x71, 0x00, 0x00, 0x3F, 0xDE, 0xA7, 0x12, 0x3F, 0xDE, 0xA7, 0x12, 0x80, 0x06, 0xB5, 0x63, 0xE1,
	0x39, 0, 2, 0x6F, 0x15,
	0x39, 0, 16, 0xC9, 0x71, 0xB5, 0xC6, 0x82, 0x1C, 0x2D, 0x33, 0xE0, 0x29, 0x71, 0x0F, 0x99, 0x99, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x24,
	0x39, 0, 8, 0xC9, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,

	0x39, 0, 2, 0x6F, 0x00,
	0x39, 0, 22, 0xCA, 0x27, 0x00, 0x29, 0x71, 0x28, 0xA4, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3F, 0xDF, 0x4C, 0x08, 0x80, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x15,
	0x39, 0, 16, 0xCA, 0x72, 0x1D, 0xC6, 0x82, 0x83, 0x2D, 0x33, 0xD0, 0x00, 0x00, 0x03, 0x67, 0x9A, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x24,
	0x39, 0, 8, 0xCA, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,

	0x39, 0, 2, 0x6F, 0x00,
	0x39, 0, 22, 0xCB, 0x2D, 0x00, 0x28, 0xA4, 0x29, 0x71, 0x00, 0x00, 0x3F, 0xDF, 0x4C, 0x08, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x15,
	0x39, 0, 16, 0xCB, 0x81, 0xB5, 0x2E, 0x82, 0x1C, 0x94, 0x33, 0x70, 0x00, 0x00, 0x0C, 0x9A, 0x67, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x24,
	0x39, 0, 8, 0xCB, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,

	0x39, 0, 2, 0x6F, 0x00,
	0x39, 0, 22, 0xCC, 0x2B, 0x00, 0x28, 0xA4, 0x28, 0xA4, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x00, 0x00, 0x00, 0x7F, 0xF9, 0x8C, 0x56, 0xF0,
	0x39, 0, 2, 0x6F, 0x15,
	0x39, 0, 16, 0xCC, 0x82, 0x1D, 0x2E, 0x82, 0x83, 0x94, 0x33, 0x8F, 0xD7, 0x5C, 0x00, 0x66, 0x66, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x24,
	0x39, 0, 8, 0xCC, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
/////////////////
	0x39, 0, 6, 0xF0, 0x55, 0xAA, 0x52, 0x08, 0x02,
	0x39, 0, 2, 0x6F, 0x08,
	0x39, 0, 3, 0xD0, 0x0C, 0xE4,
	0x39, 0, 2, 0x6F, 0x0A,
	0x39, 0, 3, 0xD0, 0x0B, 0x60,
	0x39, 0, 2, 0x6F, 0x0C,
	0x39, 0, 3, 0xD0, 0x0E, 0x30,
	0x39, 0, 2, 0xD1, 0x41,
	0x39, 0, 2, 0x6F, 0x01,
	0x39, 0, 2, 0xD1, 0x00,
	0x39, 0, 2, 0x6F, 0x02,
	0x39, 0, 2, 0xD1, 0x00,
	// ʼãֻһεķΧ
	0x39, 0, 2, 0x6F, 0x03,
	0x39, 0, 5, 0xD1, 0x02, 0x1D, 0x08, 0x2E,
	0x39, 0, 2, 0x6F, 0x07,
	0x39, 0, 5, 0xD1, 0x01, 0xB5, 0x07, 0xC6,
//	0x39, 0, 5, 0xD1,0x01,0xB5,0x07,0x92,
	0x39, 0, 2, 0x6F, 0x0B,
	0x39, 0, 5, 0xD1, 0x02, 0x83, 0x08, 0x94,
//	0x39, 0, 5, 0xD1,0x02,0x83,0x08,0xC8,

	0x39, 0, 2, 0x6F, 0x0F,
	0x39, 0, 7, 0xD1, 0x3F, 0xFF, 0x20, 0x00, 0x30, 0x00,
////////////////////////////////////
	0x39, 0, 6, 0xF0, 0x55, 0xAA, 0x52, 0x08, 0x00,
	0x39, 0, 2, 0x6F, 0x17,
	0x39, 0, 3, 0xB2, 0x0F, 0xFF,
	0x39, 0, 2, 0x6F, 0x1F,
	0x39, 0, 3, 0xB2, 0x00, 0x50,
//FPR1_CENTER_X=540, FPR1_CENTER_Y=2093
//FPR1_EN = 1  ƶλã228x,72By
	0x39, 0, 2, 0x88, 0x01,
	0x39, 0, 2, 0x6F, 0x01,
//	0x39, 0, 5, 0x88,0x02,0x28,0x07,0x2B,
	0x39, 0, 5, 0x88, 0x02, 0x1D, 0x07, 0x19, // 0x02,0x28,0x07,0x2B,
///FPR ON
//	0x39, 0, 4, 0x87,0x13,0xFF,0x05,
///FPR OFF
//	0x39, 0, 2, 0x6F,0x02,
//	0x39, 0, 2, 0x87,0x04,
#else
//v2
	0x39, 0, 6, 0xF0, 0x55, 0xAA, 0x52, 0x08, 0x07,
// ##Enable Round
	0x39, 0, 15, 0xC0, 0x01, 0x01, 0x00, 0x00, 0x55, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x00,
	0x39, 0, 22, 0xC9, 0x21, 0x00, 0x2A, 0x40, 0x2A, 0x40, 0x00, 0x00, 0x3F, 0xDD, 0xAC, 0x00, 0x3F, 0xDD, 0xAC, 0x00, 0x80, 0x06, 0xF9, 0x10, 0x00,
	0x39, 0, 2, 0x6F, 0x15,
	0x39, 0, 16, 0xC9, 0x61, 0xB4, 0xB0, 0x72, 0x1C, 0x18, 0x33, 0xE0, 0x2A, 0x40, 0x0F, 0x98, 0x98, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x24,
	0x39, 0, 8, 0xC9, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x00,
	0x39, 0, 22, 0xCA, 0x27, 0x00, 0x2A, 0x40, 0x2A, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3F, 0xDD, 0xAC, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x15,
	0x39, 0, 16, 0xCA, 0x62, 0x1D, 0xB0, 0x72, 0x85, 0x18, 0x33, 0xE0, 0x00, 0x00, 0x03, 0x68, 0x98, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x24,
	0x39, 0, 8, 0xCA, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x00,
	0x39, 0, 22, 0xCB, 0x2D, 0x00, 0x2A, 0x40, 0x2A, 0x40, 0x00, 0x00, 0x3F, 0xDD, 0xAC, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x15,
	0x39, 0, 16, 0xCB, 0x71, 0xB4, 0x19, 0x72, 0x1C, 0x81, 0x33, 0x90, 0x00, 0x00, 0x0C, 0x98, 0x68, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x24,
	0x39, 0, 8, 0xCB, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x00,
	0x39, 0, 22, 0xCC, 0x2B, 0x00, 0x2A, 0x40, 0x2A, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x00, 0x00, 0x00, 0x7F, 0xF9, 0x06, 0xF0, 0x00,
	0x39, 0, 2, 0x6F, 0x15,
	0x39, 0, 16, 0xCC, 0x72, 0x1D, 0x19, 0x72, 0x85, 0x81, 0x33, 0x9F, 0xD5, 0xC0, 0x00, 0x68, 0x68, 0x00, 0x00,
	0x39, 0, 2, 0x6F, 0x24,
	0x39, 0, 8, 0xCC, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
/////////////////
	// ڸ
	/*	0x39, 0, 6, 0xF0,0x55,0xAA,0x52,0x08,0x02,
		0x39, 0, 2, 0x6F,0x08,
		0x39, 0, 3, 0xD0,0x0C,0xE4,
		0x39, 0, 2, 0x6F,0x0A,
		0x39, 0, 3, 0xD0,0x0B,0x60,
		0x39, 0, 2, 0x6F,0x0C,
		0x39, 0, 3, 0xD0,0x0E,0x30,
	*/
	0x39, 0, 6, 0xF0, 0x55, 0xAA, 0x52, 0x08, 0x02,
	0x39, 0, 2, 0x6F, 0x08,
	0x39, 0, 3, 0xD0, 0x0B, 0xE4,
	0x39, 0, 2, 0x6F, 0x0A,
	0x39, 0, 3, 0xD0, 0x0A, 0x60,
	0x39, 0, 2, 0x6F, 0x0C,
	0x39, 0, 3, 0xD0, 0x0C, 0x30,

	0x39, 0, 2, 0xD1, 0x41,
	0x39, 0, 2, 0x6F, 0x01,
	0x39, 0, 2, 0xD1, 0x00,
	0x39, 0, 2, 0x6F, 0x02,
	0x39, 0, 2, 0xD1, 0x00,
	0x39, 0, 2, 0x6F, 0x03,
	0x39, 0, 5, 0xD1, 0x02, 0x1E, 0x07, 0x19,
	0x39, 0, 2, 0x6F, 0x07,
	0x39, 0, 5, 0xD1, 0x01, 0xB0, 0x06, 0xAC,
	0x39, 0, 2, 0x6F, 0x0B,
	0x39, 0, 5, 0xD1, 0x02, 0x88, 0x0F, 0x84,
	0x39, 0, 2, 0x6F, 0x0F,
	0x39, 0, 7, 0xD1, 0x3F, 0xFF, 0x20, 0x00, 0x30, 0x00,
////////////////////////////////////
	0x39, 0, 6, 0xF0, 0x55, 0xAA, 0x52, 0x08, 0x00,
	0x39, 0, 2, 0x6F, 0x17,
	0x39, 0, 3, 0xB2, 0x07, 0xFF,	//  DBV
	0x39, 0, 2, 0x6F, 0x1F,
	0x39, 0, 3, 0xB2, 0x00, 0x50,
///////////////////
//FPR1_CENTER_X=540, FPR1_CENTER_Y=2093
//FPR1_EN = 1
	0x39, 0, 2, 0x88, 0x01,
	0x39, 0, 2, 0x6F, 0x01,
	0x39, 0, 5, 0x88, 0x02, 0x1D, 0x07, 0x19,
///FPR ON
//	0x39, 0, 4, 0x87,0x13,0xFF,0x05,
///FPR OFF
//	0x39, 0, 2, 0x6F,0x02,
//	0x39, 0, 2, 0x87,0x04,

#endif

#endif
#if 1    //20221129 wlx su
	0x39, 0, 6, 0xF0, 0x55, 0xAA, 0x52, 0x08, 0x00,
	0x39, 0, 2, 0xC0, 0x77,
//	0x39, 0, 5, 0x3B,0x00,0x10,0x09,0x90,
//	0x39, 0, 2, 0x90,0x00,
//	0x05, 0, 1, 0x2C,
//	0x39, 0, 3, 0x51,0x03,0x00,
#endif


#if 0//BIST MODE
	0x39, 0, 6, 0xF0, 0x55, 0xAA, 0x52, 0x08, 0x00,
	0x39, 0, 8, 0xEF, 0x01, 0x02, 0xFF, 0xFF, 0xFF, 0x17, 0xFF,
	0x39, 0, 5, 0xEE, 0x87, 0x78, 0x02, 0x40
#endif

#endif

};



static void init_panel(void)
{
	/* reset panel*/
	tx_panel_reset();

	// hal_gpio_init_output(IO_PAD_PWMEN, IO_LVL_HIGH);
	/* enter send initial code mode*/
	hal_dsi_tx_ctrl_enter_init_panel_mode();
#if  AMOLED_NT37701_CSOT667
#if PANEL_INIT_CODE_ARRAY
	send_panel_init_code(sizeof(panel_init_code), (uint8_t *) panel_init_code);
#endif
	hal_dsi_tx_ctrl_write_cmd(0x29, 0, 3, 0x51, 0x00, 0x01);  //0FFF
	hal_gpio_init_output(IO_PAD_PWMEN, IO_LVL_HIGH);
	hal_dsi_tx_ctrl_write_cmd(0x05, 0, 1, 0x11);
	delayMs(90);  //120
	Gpio_swire_output(2, 40);
	delayMs(20);

#endif

// 	hal_dsi_tx_ctrl_write_cmd(0x05, 0, 1, 0x29);

	/* exit send initial code mode*/
	hal_dsi_tx_ctrl_exit_init_panel_mode();
	TAU_LOGD("Pannel init");
	delayMs(20);
}

static void open_mipi_rx(void)
{
	/* TE */
	hal_gpio_set_mode(IO_PAD_AP_TE, IO_MODE_TEAR);

	if (g_rx_ctrl_handle == NULL)
	{
		/* rx   ctrl handle */
		g_rx_ctrl_handle = hal_dsi_rx_ctrl_create_handle();
	}
	/* ò */
	g_rx_ctrl_handle->base_info.src_w = INPUT_WIDTH;
	g_rx_ctrl_handle->base_info.src_h = INPUT_HEIGHT;
	g_rx_ctrl_handle->base_info.dst_w = OUTPUT_WIDTH;
	g_rx_ctrl_handle->base_info.dst_h = OUTPUT_HEIGHT;
	g_rx_ctrl_handle->base_info.src_frate = INPUT_FRAME_RATE;
	g_rx_ctrl_handle->base_info.src_mode = INPUT_DATA_MODE;
	g_rx_ctrl_handle->rx_color_mode = INPUT_COLOR_MODE;
	g_rx_ctrl_handle->rx_lanes = INPUT_MIPI_LANE_NUM;
	g_rx_ctrl_handle->rx_nonburst_models = INPUT_VIDEO_MODEL; /* ɲ */
	g_rx_ctrl_handle->rx_vc = INPUT_VC;
	g_rx_ctrl_handle->compress_en = INPUT_COMPRESS;
	g_rx_ctrl_handle->rx_hsclk_rate = INPUT_MIPI_LANE_RATE;
	g_rx_ctrl_handle->cus_dcs_entry_table = g_cus_rx_dcs_execute_table; /* ע DCSб */
	g_rx_ctrl_handle->rx_dcs_read_entry = ap_dcs_read; /* עdsc read ص,ѡ,˺Ϊʱcus_dcs_entry_tableִ */
	g_rx_ctrl_handle->pps_update_entry = pps_update_handle;
	g_rx_ctrl_handle->hight_performan_mode = HIGHT_PERFORMAN_L1;/////////////////////////	0/1/2
#if 1//򿪻ᵼ¿ӡϢTX
//   g_rx_ctrl_handle->pq_marginal = PQ_TYPE_5;
#endif
	/* ǰԤPPS,  AP PPS cmdҲ */
	if (g_rx_ctrl_handle->compress_en == true)
	{

		uint8_t pps[128] = {0x11, 0x00, 0x00, 0x89, 0x30, 0x80, 0x0C, 0x30, 0x05, 0xA0, 0x00, 0x34, 0x02, 0xD0, 0x02, 0xD0,
		                    0x02, 0x00, 0x02, 0x68, 0x00, 0x20, 0x05, 0xC6, 0x00, 0x0A, 0x00, 0x0C, 0x01, 0xE2, 0x01, 0x78,
		                    0x18, 0x00, 0x10, 0xF0, 0x03, 0x0C, 0x20, 0x00, 0x06, 0x0B, 0x0B, 0x33, 0x0E, 0x1C, 0x2A, 0x38,
		                    0x46, 0x54, 0x62, 0x69, 0x70, 0x77, 0x79, 0x7B, 0x7D, 0x7E, 0x01, 0x02, 0x01, 0x00, 0x09, 0x40,
		                    0x09, 0xBE, 0x19, 0xFC, 0x19, 0xFA, 0x19, 0xF8, 0x1A, 0x38, 0x1A, 0x78, 0x1A, 0xB6, 0x2A, 0xF6,
		                    0x2B, 0x34, 0x2B, 0x74, 0x3B, 0x74, 0x6B, 0xF4, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		                    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		                    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
		                   };

		hal_dsi_rx_ctrl_pre_init_pps(g_rx_ctrl_handle, pps, 128);
	}
	/* ʼrx ctrl */
	hal_dsi_rx_ctrl_init(g_rx_ctrl_handle);

	hal_dsi_rx_ctrl_set_cus_sync_line(g_rx_ctrl_handle, SYNC_LIN_NUMBER);		// Ҫ򿪡˺
//	hal_dsi_rx_ctrl_set_cus_esc_clk(g_rx_ctrl_handle,20000000);
//	hal_dsi_rx_ctrl_hight_performan_mode(g_rx_ctrl_handle);/////////////////////////
//    hal_dsi_rx_ctrl_set_cus_pq_gain(g_rx_ctrl_handle,256, 256, 211);
//    hal_dsi_rx_ctrl_set_te_waveform(g_rx_ctrl_handle, false, 512);

	/* rx ctrl */
	hal_dsi_rx_ctrl_start(g_rx_ctrl_handle);
}

static void init_mipi_tx(void)
{
	if (g_tx_ctrl_handle == NULL)
	{
		g_tx_ctrl_handle = hal_dsi_tx_ctrl_create_handle();
	}
	g_tx_ctrl_handle->channel_id = OUTPUT_VC;
	g_tx_ctrl_handle->lane_num = OUTPUT_LANE_NUMBER;
	g_tx_ctrl_handle->vid_mode = OUTPUT_VIDEO_MODEL;
	g_tx_ctrl_handle->cmd_tx_type = _CMD_TYPE;
	g_tx_ctrl_handle->dpi_vsa = OUTPUT_VSA;
	g_tx_ctrl_handle->dpi_vbp = OUTPUT_VBP;
	g_tx_ctrl_handle->dpi_vfp = OUTPUT_VFP;
	g_tx_ctrl_handle->dpi_hsa = OUTPUT_HSA;
	g_tx_ctrl_handle->dpi_hbp = OUTPUT_HBP;
	g_tx_ctrl_handle->dpi_hfp = OUTPUT_HFP;
	g_tx_ctrl_handle->base_info.src_w = INPUT_WIDTH;
	g_tx_ctrl_handle->base_info.src_h = INPUT_HEIGHT;
	g_tx_ctrl_handle->base_info.dst_w = OUTPUT_WIDTH;
	g_tx_ctrl_handle->base_info.dst_h = OUTPUT_HEIGHT;
	g_tx_ctrl_handle->base_info.src_frate = INPUT_FRAME_RATE;
	g_tx_ctrl_handle->base_info.src_mode = INPUT_DATA_MODE;
	g_tx_ctrl_handle->tx_frame_rate = OUTPUT_FRAME_RATE;//OUTPUT_FRAME_RATE;
	g_tx_ctrl_handle->tx_clkawayshs = true;
//    g_tx_ctrl_handle->tx_line_delay = TX_LINE_DELAY;
	g_tx_ctrl_handle->lp_exit_lpdt = true;

	hal_dsi_tx_ctrl_init(g_tx_ctrl_handle);
	/* AP ûзʱĬϵʾɫ, Ϊ0 0 0(ɫ), ɫΪdebugʹ */
#ifndef DISPLAY_ONLY
	hal_dsi_tx_ctrl_set_overwrite_rgb(0x00, 0x00, 0x00);
#else
	hal_dsi_tx_ctrl_set_overwrite_rgb(0x00, 0x00, 0xFF);
#endif
}

static void tx_display_on(void)
{
	init_panel();

	//	swire_init();
	hal_dsi_tx_ctrl_start(g_tx_ctrl_handle);

	if(phone_DisplayOFF_flag == 1)/////////////////////////////2023/4/26 19:40:52
	{
		delayMs(300);//ʱ,⿪
	}

	hal_dsi_tx_ctrl_write_cmd(0x05, 0, 1, 0x29);

#if 0
	if(g_resolution_change)
	{
		hal_dsi_rx_ctrl_toggle_resolution(g_rx_ctrl_handle);
		//hal_dsi_rx_ctrl_set_auto_hw_filter(g_rx_ctrl_handle, true);
		//TAU_LOGD("resolutio toggle\n");
	}
	panel_display_done = true;
#endif
}

static void swire_timer_callback(void *data)
{
#ifdef USE_FOR_SUMSUNG_S20
	if(Flag_blacklight_EN)
	{
		hal_swire_start(12, 12, 12, 12, SWIRE_DEFAULT_NUM);
	}
	else if(s20_power_on_flag)
	{
		hal_swire_start(12, 12, 12, 12, SWIRE_DEFAULT_NUM);
	}
	else
#endif
	{
		hal_swire_start(12, 12, 12, 12, swire_num);
	}
}

static void swire_callback(void *data)
{
	/* swire ǷҪһֱҪֻֻͬͬ */
	//if(start_display_on == false)
	{
		hal_timer_start(SWIRE_TIMER, 26, swire_timer_callback, NULL);
	}
}

/* swire ʼ,ͨ hal_swire_start , ѭһֱ */
static __attribute__((unused)) void swire_init(void)
{
	hal_swire_open(DISABLE);
	hal_swire_init();
	/* swire ηɺص */
	hal_swire_register_callback(swire_callback);
	hal_swire_open(ENABLE);
	//hal_swire_start(12, 12, 12, 12, 43);
	hal_swire_start(12, 12, 12, 12, SWIRE_DEFAULT_NUM); //3~27,~,9.45V~7.43V
	hal_timer_init(SWIRE_TIMER);
	hal_timer_start(SWIRE_TIMER, 26, swire_timer_callback, NULL);
}

static void soft_te_timer_cb(void *data)
{
	/*
	    S8 ӵTP1.8V, AC ҪȵTP1.8 ٳʼ, TP ǰҪͨTEֻֻ
	*/
//    if (panel_display_done == false)
//    {
	hal_dsi_rx_ctrl_gen_a_tear_signal(g_rx_ctrl_handle);
	hal_timer_start(TE_TIMER, 17, soft_te_timer_cb, NULL);
//    }
//    else
//    {
//        hal_dsi_rx_ctrl_set_hw_tear_mode(g_rx_ctrl_handle);
//    }
}

void soft_te_timer_init()//static
{
	TAU_LOGD("soft_te_timer_init");
	hal_dsi_rx_ctrl_set_sw_tear_mode(g_rx_ctrl_handle);
	hal_timer_init(TE_TIMER);
	hal_timer_start(TE_TIMER, 1, soft_te_timer_cb, NULL);
}

#ifdef ADD_TIMER3_FUNCTION
static void soft_timer3_cb(void *data)
{
	hal_timer_start(TIMER_NUM3, 10, soft_timer3_cb, NULL);
	tp_sleep_count++;
	if(phone_DisplayOFF_count > 0)
	{
		phone_DisplayOFF_count++;
	}

#if AUTO_CAL_TP
	if (g_exit_sleep_mode)
	{
		if (g_cal_cnt > 0)
		{
			g_cal_cnt--;
			if (g_cal_cnt == 0)
			{
				g_calibration_flag = true;
				TAU_LOGD("Start cal tp!\n");
			}
		}
	}
#endif

#if RUN_TEST
	g_run_test_cnt++;
#endif
}
#endif

#if ADD_TP_CALIBRATION
void app_tp_calibration_exec(void)
{
	if(g_calibration_flag)
	{
		g_calibration_flag = false;
		ap_tp_calibration();
		TAU_LOGD("calibration successful \n");
	}
}
#endif

#if 0 // TEST RGB, From Lin
void RGB_TEST(void)
{
	tx_display_on();
	while (1)
	{
		hal_dsi_tx_ctrl_start(g_tx_ctrl_handle);
		hal_dsi_tx_ctrl_set_overwrite_rgb(0xFF, 0x00, 0x00); // RED
		delayMs(1000);

		hal_dsi_tx_ctrl_start(g_tx_ctrl_handle);
		hal_dsi_tx_ctrl_set_overwrite_rgb(0x00, 0xFF, 0x00); // GREEN
		delayMs(1000);

		hal_dsi_tx_ctrl_start(g_tx_ctrl_handle);
		hal_dsi_tx_ctrl_set_overwrite_rgb(0x00, 0x00, 0xFF); // BLUE
		delayMs(1000);

		hal_dsi_tx_ctrl_start(g_tx_ctrl_handle);
		hal_dsi_tx_ctrl_set_overwrite_rgb(0xFF, 0xFF, 0xFF); // WHITE
		delayMs(1000);

		hal_dsi_tx_ctrl_start(g_tx_ctrl_handle);
		hal_dsi_tx_ctrl_set_overwrite_rgb(0x00, 0x00, 0x00); // BLACK
		delayMs(1000);

		hal_dsi_tx_ctrl_set_partial_disp(DISABLE);
		hal_dsi_tx_ctrl_set_partial_disp(ENABLE);
		delayMs(1000);

		hal_dsi_tx_ctrl_set_partial_disp_area(0, 0, 0, 0);
	}

}
#endif

//void tp_heartbeat_exec(void)
//{
//	if (s_screen_init_complate)
//	{
//		if(hal_gpio_get_input_data(IO_PAD_TD_INT))
//		{
//			s_heartbeat = 0;
//		}
//		else
//		{
//			if(s_heartbeat < (65536 / 50)) // 65536*3 = 900ms  65536/50 = 6ms
//			{
//				s_heartbeat ++;
//			}
//			else
//			{
//				TAU_LOGD("hb");
//				s_heartbeat = 0;
//				ap_tp_system_softReset();
//			}
//		}
//	}
//}

#if 0//TEST
static uint8_t power_on_flag = 0;
static void ap_reset_cb_test(void *data)
{
	/* лԴ */
	//    hal_gpio_set_output_data_ex(POWER_IO_B, IO_LVL_HIGH, POWER_IO_A, IO_LVL_LOW);
	/* VCC */
	TAU_LOGD("ap reset cb!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!\n");
	hal_gpio_set_ap_reset_int(DISABLE, ap_reset_cb_test, DETECT_HIGH_LVL);
	power_on_flag = 1;
	//hal_system_set_vcc(true);
	//NVIC_SystemReset();
}
#endif



extern void tp_io_init(void);
extern void tp_proc(void);

void ap_demo(void)
{
	//for checksum
	char u8_date_inv[11] = {~__DATE__[0], ~__DATE__[1], ~__DATE__[2], ~__DATE__[3], \
	                        ~__DATE__[4], ~__DATE__[5], ~__DATE__[6], ~__DATE__[7], \
	                        ~__DATE__[8], ~__DATE__[9], ~__DATE__[10]
	                       };
	char u8_time_inv[8] = {~__TIME__[0], ~__TIME__[1], ~__TIME__[2], ~__TIME__[3], \
	                       ~__TIME__[4], ~__TIME__[5], ~__TIME__[6], ~__TIME__[7]
	                      };



#if 0//TEST
	hal_gpio_set_ap_reset_int(ENABLE, ap_reset_cb_test, DETECT_HIGH_LVL);
	while(power_on_flag == 0)
	{
		;
	}
#endif

	hal_gpio_set_output_data(IO_PAD_TD_LEDPWM, IO_LVL_LOW);
	hal_gpio_init_output(IO_PAD_TD_TPRSTN, IO_LVL_HIGH);
	hal_gpio_init_output(IO_PAD_AP_SWIRE, IO_LVL_LOW);
	hal_gpio_init_output(IO_PAD_PWMEN, IO_LVL_LOW);  // LED_ON

	open_mipi_rx();
	//TAU_LOGD("Pixe6 [%s %s]", __DATE__, __TIME__);
	TAU_LOGD("Pixel7pro [%s %s %s %s]", __DATE__, __TIME__, u8_date_inv[0], u8_time_inv[0]);

	tp_io_init();
//	slave_SPI_init();

	init_mipi_tx();

	//hal_dsi_rx_ctrl_set_tear_mode_ex(g_rx_ctrl_handle, SYNC_LIN_NUMBER, TE_USER_MODE);

	//soft_te_timer_init();

//	app_tp_init();

#ifdef ADD_TIMER3_FUNCTION
	tp_sleep_count = 0;
	phone_DisplayOFF_count = 1;
	hal_timer_init(TIMER_NUM3);
	hal_timer_start(TIMER_NUM3, 10, soft_timer3_cb, NULL);
	TAU_LOGD("start timer3");
#endif

#if 1 // TEST RGB, From Lin
//	RGB_TEST();
//hal_dsi_tx_ctrl_set_overwrite_rgb(0xff, 0xff, 0xff);
#endif


	while (1)
	{
		tp_proc();

		if (start_display_on == true )
		{
			tx_display_on();
			start_display_on = false;
			panel_display_done = true;
#ifndef DISABLE_TDDI_I2C_FUNCTION
			/* TP ģͨѶʼ */
			app_tp_transfer_screen_start();
#endif

#if ENABLE_TP_WAKE_UP//жϷԭǵʱλһ(70ms)Ḷ́ΪֿʹԽж70ms,ʹøλڶʱʶ
			hal_gpio_set_ap_reset_int(ENABLE, ap_reset_cb, DETECT_RISING_EDGE);
#endif
		}

//		if(phone_start_flag)
//		{
//			FST_tp_init();
//			phone_start_flag =0;
//		}


//		if(phone_DisplayOFF_flag == 1)
//		{
//			if(phone_DisplayOFF_count > 1000)
//			{
//				phone_DisplayOFF_count = 0;
//				phone_start_flag = 1;
//			}
//		}
//		else
//		{
//			if(phone_DisplayOFF_count > 20)
//			{
//				phone_DisplayOFF_count = 0;
//				phone_start_flag = 1;
//				hal_gpio_set_output_data(IO_PAD_AP_INT, IO_LVL_LOW); //ͣ˫2~3s޴.jason_su
//			}
//		}



//		app_tp_transfer_screen_int();

#if ADD_TP_CALIBRATION
		app_tp_calibration_exec();
#endif

//		tp_heartbeat_exec();
//		ap_tp_scan_point_record_event_exec();

		if(g_mipi_path_off == false)
		{
			while (hal_dsi_rx_ctrl_dsc_async_handler(g_rx_ctrl_handle));
		}

#if  ENABLE_TP_WAKE_UP
		if (g_need_enter_sleep_mode)
		{
			g_mipi_path_off = true;
			hal_gpio_set_output_data(IO_PAD_TD_LEDPWM, IO_LVL_HIGH);
			/* FIXME stop more model */
			hal_dsi_tx_ctrl_stop(g_tx_ctrl_handle);
			hal_dsi_tx_ctrl_deinit(g_tx_ctrl_handle);
			hal_dsi_rx_ctrl_stop(g_rx_ctrl_handle);
			hal_dsi_rx_ctrl_deinit(g_rx_ctrl_handle);

			hal_swire_open(DISABLE);
			hal_swire_deinit();
			hal_timer_stop(SWIRE_TIMER);
			hal_timer_deinit(SWIRE_TIMER);
			tp_sleep_in = 1;
			//hal_gpio_init_output(IO_PAD_TD_TPRSTN, IO_LVL_LOW);
			hal_system_set_vcc(false);	 //VCC

			TAU_LOGD("disable video path \n");
			g_need_enter_sleep_mode = false;
		}
#endif

		/* enter idle mode*/
		//hal_system_idle_mode(true);
	}
}


